//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <string.h>
#include "ERep.h"

static void __GetTmpFileName(char * cpTempFile /*Must be MAX_PATH + 1 length*/);

//---------------------------------------------------------------------------
__fastcall TERpt::TERpt(void) : TThread(true){
  Priority = tpNormal;
  FreeOnTerminate = false;
  FOnSylkReportMessage = NULL;
  fhInBlank = INVALID_HANDLE_VALUE;
  fhOutBlank = INVALID_HANDLE_VALUE;
  FOutStream = NULL;
  WriteStreamPtr = NULL;
  FInStream = NULL;
  FReadStreamPtr = NULL;
  uipWidths = NULL;
  uipLines = NULL;
  FCharByNum = REQUEST_DATA_BY_NUM_SYMBOL_FOR_SYLK;
  FCharByName = REQUEST_DATA_BY_NAME_SYMBOL;
  FLastDynSection = 13;
  FLastDynSectionH = 13;
  lWM_REP_SECTION_PREPARE = false;
  ucpInBuff = StrAlloc(FILE_BUFFER);
  ucpOutBuff = StrAlloc(FILE_BUFFER);
};

//---------------------------------------------------------------------------
__fastcall TERpt::~TERpt(void){
  if (uipWidths != NULL)
    SysFreeMem((void*)uipWidths);
  if (uipLines != NULL)
    SysFreeMem((void*)uipLines);
  StrDispose(ucpInBuff);
  StrDispose(ucpOutBuff);
};

//---------------------------------------------------------------------------
int __fastcall TERpt::ParseWidth(char* RegionD, int &iMin, int &iMax, int &iWidth){
  int   i, j;
  char  cc;
  i = 0;
  j = 0;
  iMin = RowsP(RegionD);
  while ( true ){
    cc = *(RegionD + i);
    if ( cc == ' ' ){
      if ( j == 0 ) iMax = RowsP(RegionD + i + 1);
      if ( j == 1 ) iWidth = RowsP(RegionD + i + 1);
      j++;
    };
    i++;
    if ( cc == 0xD ) break;
  };
  return i;
};

//---------------------------------------------------------------------------
void __fastcall TERpt::lpRepBegin(void){
  bool                  CreateOK;
  int                   uiI, uiJ, uiK, uiRW;
  FoundPar              fppP;
  fhOkIn = false;
  fhOkOut = false;
  FTypeDiraction = tdVerticaly;
  FLastDynSection = 13;
  lWM_REP_SECTION_PREPARE = false;
  for ( uiI = 0; uiI < MAX_SECTION_NUM; uiI ++)
    Sections[uiI].ucUsed = false;
  if ( FOnSylkReportMessage != NULL ) FOnSylkReportMessage(this, WM_REP_START_REPORT, 0, 0);
  CreateOK = true;
  if ( InputBlank != "" ){
    fhInBlank = CreateFile(InputBlank.c_str(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, (LPSECURITY_ATTRIBUTES)NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
    CreateOK = (fhInBlank != INVALID_HANDLE_VALUE);
    fhOkIn = true;
  } else {
    CreateOK = ( (FInStream != NULL) || (FReadStreamPtr != NULL) );
  };
  if ( CreateOK ){
    CreateOK = true;
    if ( OutputBlank != "" ){
      fhOutBlank = CreateFile(OutputBlank.c_str(), GENERIC_READ | GENERIC_WRITE, 0, (LPSECURITY_ATTRIBUTES)NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
      CreateOK = (fhOutBlank != INVALID_HANDLE_VALUE);
      fhOkOut = true;
    } else {
      CreateOK = ( (FOutStream != NULL) || (FWriteStreamPtr != NULL) );
    };
		if (CreateOK){
      CreateOK = false;
      uiSizeIn = 0;
      if ( fhOkIn ){
        SetFilePointer(fhInBlank, 0x0, NULL, FILE_BEGIN);
        CreateOK = ReadFile(fhInBlank, (LPVOID)ucpInBuff, FILE_BUFFER, (LPDWORD)&uiSizeIn, NULL);
      } else {
        if ( FInStream != NULL ){
          FInStream->Seek(0, soFromBeginning);
          uiSizeIn = FInStream->Read((LPVOID)ucpInBuff, FILE_BUFFER);
          CreateOK = true;
        } else {
          if ( FReadStreamPtr != NULL ){
            uiSizeIn = (*FReadStreamPtr)(ucpInBuff, FILE_BUFFER, NULL);
            CreateOK = true;
          };
        };
      };
      if ( CreateOK ){
        if (uiSizeIn > 0){
          uiOutP = 0;
          uiI = 0;
          uiJ = 0;
          while ( uiI < uiSizeIn ){
            if ( ucpInBuff[uiI] == 0x0D ) uiJ++;
            uiI++;
          };
          uiInLines = uiJ;
          if (uipLines != NULL)
            SysFreeMem((void*)uipLines);
          uipLines = (int*)SysGetMem(uiInLines * sizeof(int));
          uiI = 0;
          uiJ = 0;
          uiK = 0;
          while (uiI < uiSizeIn){
            if ( ucpInBuff[uiI] == 0x0D ){
              uipLines[uiJ] = uiK;
              uiJ++;
              uiK = uiI + 2;
            };
            uiI++;
          };
          SeekLastNN(fppP);
          if ( fppP.bF ){

            Sections[0].Name = "FILEHEADER";
            Sections[0].BeginR = 0;
            Sections[0].EndR = 0;
            Sections[0].ucUsed = true;

            _PrepareSection(Sections[1],  "REPORTHEADER", 1);
            _PrepareSection(Sections[2],  "GROUPHEADER", 2);
            _PrepareSection(Sections[3],  "SUBGROUPHEADER", 3);
            _PrepareSection(Sections[4],  "SUBSUBGROUPHEADER", 4);
            _PrepareSection(Sections[5],  "SUPERSUBGROUPHEADER", 5);
            _PrepareSection(Sections[6],  "BODY", 6);
            _PrepareSection(Sections[7],  "SUPERSUBGROUPFOOTER", 7);
            _PrepareSection(Sections[8],  "SUBSUBGROUPFOOTER", 8);
            _PrepareSection(Sections[9],  "SUBGROUPFOOTER", 9);
            _PrepareSection(Sections[10], "GROUPFOOTER", 10);
            _PrepareSection(Sections[11], "REPORTFOOTER", 11);

            Sections[12].Name = "FILEFOOTER";
            Sections[12].BeginR = 0;
            Sections[12].EndR = 0;
            Sections[12].ucUsed = true;
            //
            CurrRow = 1;
            //
            _OutSection(true, 0);

            lWM_REP_SECTION_PREPARE = true;
            if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_SECTION_PREPARE, 0, 0);
            lWM_REP_SECTION_PREPARE = true;

            _OutSection(true, 1);
            uiJ = 1;
            bCheck = false;
            if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_MOVE, uiJ, MOVE_TOP);
            while ( ! bCheck ) {

              _OutSection(false, 2);
              _OutSection(false, 3);
              _OutSection(false, 4);
              _OutSection(false, 5);
              _OutSection(true, 6);
              _OutSection(false, 7);
              _OutSection(false, 8);
              _OutSection(false, 9);
              _OutSection(false, 10);

              bCheck = false;
              if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_MOVE, uiJ, MOVE_NEXT);
              uiJ ++;
            };
            _OutSection(true, 11);
            _OutSection(true, 12);
            CloseSections();
            if ( uiOutP > 0 ){
              if ( FOutStream == NULL ){
                WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
              } else {
                uiRW = FOutStream->Write(ucpOutBuff, uiOutP);
              };
              if (uiOutP != uiRW){
                if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
                //raise Exception.Create('WRITE_EXCEPTION');
              };
              uiOutP = 0;
            };
          } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_SECTION_ERROR, 0, 0);
        } else if (FOnSylkReportMessage != NULL ) FOnSylkReportMessage(this, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      } else if (FOnSylkReportMessage != NULL ) FOnSylkReportMessage(this, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      if ( fhOkOut ) CloseHandle(fhOutBlank);
    } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_CREATE_ERROR, 0, 0);
    if ( fhOkIn ) CloseHandle(fhInBlank);
  } else if ( FOnSylkReportMessage != NULL ) FOnSylkReportMessage(this, WM_REP_OPEN_ERROR, 0, 0);
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_END_REPORT, 0, 0);
};

//---------------------------------------------------------------------------
void __fastcall TERpt::lpRepBeginHorizontaly(void){
  bool                  CreateOK;
  int                   uiI, uiJ, uiK, uiRW;
  FoundPar              fppP;
  char                  cc, cc0, cc1;
  fhOkIn = false;
  fhOkOut = false;
  FTypeDiraction = tdHorizontaly;
  FLastDynSectionH = 13;
  lWM_REP_SECTION_PREPARE = false;
  for (uiI = 0; uiI < MAX_SECTION_NUM; uiI++)
    SectionsH[uiI].ucUsed = false;
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_START_REPORT, 0, 0);
  CreateOK = true;
  if ( InputBlank != "" ){
    fhInBlank = CreateFile(InputBlank.c_str(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, (LPSECURITY_ATTRIBUTES)NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
    CreateOK = (fhInBlank != INVALID_HANDLE_VALUE);
    fhOkIn = true;
  } else {
    CreateOK = ( (FInStream != NULL) || (FReadStreamPtr != NULL) );
  };
  if ( CreateOK ){
    CreateOK = true;
    if ( OutputBlank != "" ){
      fhOutBlank = CreateFile(OutputBlank.c_str(), GENERIC_READ | GENERIC_WRITE, 0, (LPSECURITY_ATTRIBUTES)NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
      CreateOK = (fhOutBlank != INVALID_HANDLE_VALUE);
      fhOkOut = true;
    } else {
      CreateOK = ( (FOutStream != NULL) || (FWriteStreamPtr != NULL) );
    };
		if (CreateOK){
      uiSizeIn = 0;
      if ( fhOkIn ){
        SetFilePointer(fhInBlank, 0x0, NULL, FILE_BEGIN);
        CreateOK = ReadFile(fhInBlank, (LPVOID)ucpInBuff, FILE_BUFFER, (LPDWORD)&uiSizeIn, NULL);
      } else {
        if ( FInStream != NULL ){
          FInStream->Seek(0, soFromBeginning);
          uiSizeIn = FInStream->Read((LPVOID)ucpInBuff, FILE_BUFFER);
          CreateOK = true;
        } else {
          if ( FReadStreamPtr != NULL ){
            uiSizeIn = (*FReadStreamPtr)(ucpInBuff, FILE_BUFFER, NULL);
            CreateOK = true;
          };
        };
      };
      if ( CreateOK ){
        if (uiSizeIn > 0){
          uiOutP = 0;
          uiI = 0;
          uiJ = 0;
          while (uiI < uiSizeIn){
            if ( ucpInBuff[uiI] == 0x0D ) uiJ++;
            uiI++;
          };
          uiInLines = uiJ;
          if (uipLines != NULL)
            SysFreeMem((void*)uipLines);
          uipLines = (int*)SysGetMem(uiInLines * sizeof(int));
          uiI = 0;
          uiJ = 0;
          uiK = 0;
          while (uiI < uiSizeIn){
            if ( ucpInBuff[uiI] == 0x0D ){
              uipLines[uiJ] = uiK;
              uiJ++;
              uiK = uiI + 2;
            };
            uiI++;
          };
          uiJ = 0;
          for (uiI=0; uiI<uiInLines; uiI++ ){
            cc = ucpInBuff[uipLines[uiI]];
            cc0 = ucpInBuff[uipLines[uiI] + 1];
            cc1 = ucpInBuff[uipLines[uiI] + 2];
            if ( (cc == 'F') && (cc0 == ';') && (cc1 == 'W') ) uiJ++;
          };
          uiInWidths = uiJ;
          if (uipWidths != NULL)
            SysFreeMem((void*)uipWidths);
          uipWidths = (int*)SysGetMem(uiInWidths * sizeof(int));
          uiJ = 0;
          for (uiI=0; uiI<uiInLines; uiI++){
            cc = ucpInBuff[uipLines[uiI]];
            cc0 = ucpInBuff[uipLines[uiI] + 1];
            cc1 = ucpInBuff[uipLines[uiI] + 2];
            if ( (cc == 'F') && (cc0 == ';') && (cc1 == 'W') ){
              uipWidths[uiJ] = uiI;
              uiJ++;
            };
          };
          SeekLastNN(fppP);
          if ( fppP.bF ){

            SectionsH[0].Name = "FILEHEADER";
            SectionsH[0].BeginR = 0;
            SectionsH[0].EndR = 0;
            SectionsH[0].ucUsed = true;

            _PrepareSection(SectionsH[1],  "H_REPORTHEADER", 1);
            _PrepareSection(SectionsH[2],  "H_GROUPHEADER", 2);
            _PrepareSection(SectionsH[3],  "H_SUBGROUPHEADER", 3);
            _PrepareSection(SectionsH[4],  "H_SUBSUBGROUPHEADER", 4);
            _PrepareSection(SectionsH[5],  "H_SUPERSUBGROUPHEADER", 5);
            _PrepareSection(SectionsH[6],  "H_BODY", 6);
            _PrepareSection(SectionsH[7],  "H_SUPERSUBGROUPFOOTER", 7);
            _PrepareSection(SectionsH[8],  "H_SUBSUBGROUPFOOTER", 8);
            _PrepareSection(SectionsH[9],  "H_SUBGROUPFOOTER", 9);
            _PrepareSection(SectionsH[10], "H_GROUPFOOTER", 10);
            _PrepareSection(SectionsH[11], "H_REPORTFOOTER", 11);

            SectionsH[12].Name = "FILEFOOTER";
            SectionsH[12].BeginR = 0;
            SectionsH[12].EndR = 0;
            SectionsH[12].ucUsed = true;
            //
            CurrCol = 1;
            //
            _OutSectionHorizontaly(true, 0);

            lWM_REP_SECTION_PREPARE = true;
            if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_SECTION_PREPARE, 0, 0);
            lWM_REP_SECTION_PREPARE = false;

            _OutSectionHorizontaly(true, 1);
            uiJ = 1;
            bCheck = false;
            if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_MOVE, uiJ, MOVE_TOP);
            while ( ! bCheck ){

              _OutSectionHorizontaly(false, 2);
              _OutSectionHorizontaly(false, 3);
              _OutSectionHorizontaly(false, 4);
              _OutSectionHorizontaly(false, 5);
              _OutSectionHorizontaly(true, 6);
              _OutSectionHorizontaly(false, 7);
              _OutSectionHorizontaly(false, 8);
              _OutSectionHorizontaly(false, 9);
              _OutSectionHorizontaly(false, 10);

              bCheck = false;
              if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_MOVE, uiJ, MOVE_NEXT);
              uiJ++;
            };
            _OutSectionHorizontaly(true, 11);
            _OutSectionHorizontaly(true, 12);
            CloseSections();
            if ( uiOutP > 0 ) {
              if ( FOutStream == NULL ){
                WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
              } else {
                uiRW = FOutStream->Write(ucpOutBuff, uiOutP);
              };
              if (uiOutP != uiRW){
                if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
                //raise Exception.Create('WRITE_EXCEPTION');
              };
              uiOutP = 0;
            };
          } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_SECTION_ERROR, 0, 0);
        } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      if ( fhOkOut ) CloseHandle(fhOutBlank);
    } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_CREATE_ERROR, 0, 0);
    if ( fhOkIn ) CloseHandle(fhInBlank);
  } else if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_OPEN_ERROR, 0, 0);
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_END_REPORT, 0, 0);
};

//---------------------------------------------------------------------------
void __fastcall TERpt::lpRepBeginBiDirection(void){
  AnsiString  cpTempFile;
  char cpTempFileArr[MAX_PATH + 1];
  AnsiString  cpOldOut;
  cpOldOut = OutputBlank;
  __GetTmpFileName(cpTempFileArr);
  cpTempFile = cpTempFileArr;
  OutputBlank = cpTempFile;
  FTypeDiraction = tdHorizontaly;
  lpRepBeginHorizontaly();
  InputBlank = cpTempFile;
  OutputBlank = cpOldOut;
  FTypeDiraction = tdVerticaly;
  lpRepBegin();
  DeleteFile(cpTempFile);
};

//---------------------------------------------------------------------------
void __fastcall TERpt::_OutSection(const bool bDefOut, const int SectionIndex){
  int uiI, uiDataIndex, i, j, stri, k;
  char cI, cc, cc0, cc1, a0, a1, a2, a3;
  bool  yy, zz, cJ;
  int CurRow;
  int CurCol;
  char  b[20];
  int kNum;
  int LenRequestStr;
  CurRow = 1;
  CurCol = 1;
  FCurrentSection = Sections[SectionIndex].Name;
  FCurrentSectionNum = SectionIndex;
  //
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_BEGIN);
  if ( Sections[SectionIndex].ucUsed ){
    bCheck = bDefOut;
    if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_CHECK);
    if ( SectionIndex == 0 ){
      //
      for (uiI=0; uiI<uiInLines; uiI++){
        cc  = ucpInBuff[uipLines[uiI]];
        cc0 = ucpInBuff[uipLines[uiI] + 1];
        cc1 = ucpInBuff[uipLines[uiI] + 2];
        if ( ((cc != 'F') && (cc != 'C') && (cc != 'E')) || ((cc == 'F') && (cc0 == ';') && (cc1 == 'W')) ){
          stri = 0;
          while ( cc != 0x0D ){
            OutChar(cc);
            stri++;
            cc = ucpInBuff[uipLines[uiI] + stri];
          };
          OutChar(0x0D);
          OutChar(0x0A);
        };
      };
      //
      bCheck = false;
    };
    if ( SectionIndex == 12 ){
      //
      OutChar('E');
      OutChar(0x0D);
      OutChar(0x0A);
      //
      bCheck = false;
    };
    if ( bCheck ){
      for (uiI=0; uiI<uiInLines; uiI++){
        //
        yy = false;
        cc = ucpInBuff[uipLines[uiI]];
        if ( (cc == 'F') || (cc == 'C') ){
          stri = 0;
          cc = ucpInBuff[uipLines[uiI]];
          cc0 = ucpInBuff[uipLines[uiI] + 1];
          while ( cc != 0x0D ){
            if ( ((cc == ';') && (cc0 == 'R')) || ((cc == ';') && (cc0 == 'Y')) )
              CurRow = RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
            if ( ((cc == ';') && (cc0 == 'X')) )
              CurCol = RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
            stri++;
            cc = ucpInBuff[uipLines[uiI] + stri];
            cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
          };
          if ( ( Sections[SectionIndex].BeginR <= CurRow ) && ( CurRow <= Sections[SectionIndex].EndR ) ) yy = true;
        };
        //
        zz = false;
        if ( yy ){
          stri = 0;
          cc = ucpInBuff[uipLines[uiI]];
          cc0 = ucpInBuff[uipLines[uiI] + 1];
          while ( cc != 0x0D ){
            if ( (cc == ';') && (cc0 == 'X') )  zz = true;
            if ( (cc == ';') && (cc0 == 'Y') ) {
              k = 0;
              while ( true ){
                cc1 = ucpInBuff[uipLines[uiI] + 2 + stri + k];
                if ( ! ((0x030 <= cc1) && (cc1 <= 0x039)) ){
                  break;
                } else
                  k++;
              };
              stri = stri + k + 2;
              cc = ucpInBuff[uipLines[uiI] + stri];
              cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              OutChar(';');
              OutChar('Y');
              sprintf(b, "%d", CurrRow + CurRow - Sections[SectionIndex].BeginR);
              k = 0;
              while ( b[k] > 0 ){
                OutChar(b[k]);
                k++;
              };
              zz = true;
            };
            //
            if ( (cc == ';') && (cc0 == 'R') ){
              k = 0;
              while ( true ){
                cc1 = ucpInBuff[uipLines[uiI] + 2 + stri + k];
                if ( ! ((0x030 <= cc1) && (cc1 <= 0x039)) ){
                  break;
                } else
                  k++;
              };
              stri = stri + k + 2;
              cc = ucpInBuff[uipLines[uiI] + stri];
              cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              OutChar(';');
              OutChar('R');
              //StrFmt(b, "%d", ARRAYOFCONST((CurrRow + CurRow - Sections[SectionIndex].BeginR)));
              sprintf(b, "%d", CurrRow + CurRow - Sections[SectionIndex].BeginR);
              k = 0;
              while ( b[k] > 0 ){
                OutChar(b[k]);
                k++;
              };
            };
            //
            //Request by VALUE
            if ( (cc == ';') && (cc0 == 'K') ){
              kNum = RowsPExact(ucpInBuff + uipLines[uiI] + stri + 2);
              if ( kNum != 0 ){
                k = 0;
                if ( kNum < 0 ) k = 1;
                while ( true ){
                  cc1 = ucpInBuff[uipLines[uiI] + 2 + stri + k];
                  if ( ! ((0x030 <= cc1) && (cc1 <= 0x039)) ){
                    break;
                  } else
                    k++;
                };
                RequestStr = "";
                if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, kNum, SECTION_DATA_REQUEST_BY_VALUE);
                LenRequestStr = RequestStr.Length();
                if ( LenRequestStr > 0 ){
                  OutChar(';');
                  OutChar('K');
                  i = 1;
                  while ( i <= LenRequestStr ){
                    OutChar(RequestStr[i]);
                    i++;
                  };
                };
                stri = stri + k + 2;
                cc = ucpInBuff[uipLines[uiI] + stri];
                cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              };
            };
            //Request by number
            if ( cc == CharByNum ){    //REQUEST_DATA_BY_NUM_SYMBOL
              //Foword 4 sign
              a0 = ucpInBuff[uipLines[uiI] + stri + 1];
              a1 = ucpInBuff[uipLines[uiI] + stri + 2];
              a2 = ucpInBuff[uipLines[uiI] + stri + 3];
              a3 = ucpInBuff[uipLines[uiI] + stri + 4];
              if ( ((0x030 <= a0) && (a0 <= 0x039)) && ((0x030 <= a1) && (a1 <= 0x039)) && ((0x030 <= a2) && (a2 <= 0x039)) && ((0x030 <= a3) && (a3 <= 0x039)) ){
                uiDataIndex = (a0 - 0x030) * 1000 + (a1 - 0x030) * 100 + (a2 - 0x030) * 10 + (a3 - 0x030);
                if (uiDataIndex > 0){ //Begin with 1  !!!!
                  RequestStr = "";
                  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, uiDataIndex, SECTION_DATA_REQUEST_BY_NUM);
                  LenRequestStr = RequestStr.Length();
                  if ( LenRequestStr > 0 ){
                    i = 1;
                    while ( i <= LenRequestStr ){
                      OutChar(RequestStr[i]);
                      i++;
                    };
                  };
                  stri = stri + 5;
                  cc = ucpInBuff[uipLines[uiI] + stri];
                  cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
                };
              };
            };
            //Request by name
            if ( cc == CharByName ){    //REQUEST_DATA_BY_NAME_SYMBOL
              cFieldName = "";
              cJ = false;
              for (j=1; j<MAX_LABEL_NAME_LEGTH; j++){
                cI = ucpInBuff[uipLines[uiI] + stri + j];
                if ( cI == CharByName ){
                  cJ = true;
                  break;
                };
                cFieldName = cFieldName + cI;
              };
              if ( cJ ){  //if found
                RequestStr = "";
                if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, (int)cFieldName.c_str(), SECTION_DATA_REQUEST_BY_NAME);
                LenRequestStr = RequestStr.Length();
                if ( LenRequestStr > 0 ){
                  i = 1;
                  while ( i <= LenRequestStr ){
                    OutChar(RequestStr[i]);
                    i++;
                  };
                };
                stri = stri + j + 1;
                cc = ucpInBuff[uipLines[uiI] + stri];
                cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              };
            };
            if ( cc == 0x0D ) break;
            OutChar(cc);
            stri++;
            cc = ucpInBuff[uipLines[uiI] + stri];
            cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
          };
          OutChar(0x0D);
          OutChar(0x0A);
        };
        //

        /////////////////////////
        //Request by cell
        /////////////////////////
        if ( zz ){
          stDataRq.iTypeDataRequest = SECTION_DATA_REQUEST_BY_CELL;
          stDataRq.CurrCell.iRow = CurrRow + CurRow - Sections[SectionIndex].BeginR;
          stDataRq.CurrCell.iCol = CurCol;
          stDataRq.BlankCell.iRow = CurRow;
          stDataRq.BlankCell.iCol = CurCol;

          RequestStr = "";
          if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, (int)&stDataRq, SECTION_DATA_REQUEST_BY_CELL);
          LenRequestStr = RequestStr.Length();
          if ( LenRequestStr > 0 ){
            i = 1;
            while ( i <= LenRequestStr ){
              OutChar(RequestStr[i]);
              i++;
            };
          };

        };
        //
      };
      CurrRow += (Sections[SectionIndex].EndR - Sections[SectionIndex].BeginR + 1);
      if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_END);
    };
  };
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_COMPLIT);
  //
};

//---------------------------------------------------------------------------
void __fastcall TERpt::_OutSectionHorizontaly(const bool bDefOut, const int SectionIndex){
  int uiI, uiJ, uiDataIndex, i, j, stri, k;
  char  cI, cc, cc0, cc1, a0, a1, a2, a3;
  bool  yy, zz, cJ;
  int CurCol;
  int CurRow;
  int iMin, iMax, iWidth, WidthR;
  char  b[19];
  int kNum;
  int LenRequestStr;
  CurCol = 1;
  CurRow = 1;
  FCurrentSection = SectionsH[SectionIndex].Name;
  FCurrentSectionNum = SectionIndex;
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_BEGIN);
  if ( SectionsH[SectionIndex].ucUsed ){
    bCheck = bDefOut;
    if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_CHECK);
    if (SectionIndex == 0){
      //
      for (uiI = 0; uiI<uiInLines; uiI++){
        cc = ucpInBuff[uipLines[uiI]];
        if ( (cc != 'F') && (cc != 'C') && (cc != 'E') ){
          stri = 0;
          while ( cc != 0x0D ){
            OutChar(cc);
            stri++;
            cc = ucpInBuff[uipLines[uiI] + stri];
          };
          OutChar(0x0D);
          OutChar(0x0A);
        };
      };
      //
      bCheck = false;
    };
    if ( SectionIndex == 12 ){
      //
      OutChar('E');
      OutChar(0x0D);
      OutChar(0x0A);
      //
      bCheck = false;
    };
    if ( bCheck ){
      for (uiI=0; uiI<uiInLines; uiI++){
        //
        yy = false;
        cc = ucpInBuff[uipLines[uiI]];
        cc0 = ucpInBuff[uipLines[uiI] + 1];
        cc1 = ucpInBuff[uipLines[uiI] + 2];
        if ( ((cc == 'F') || (cc == 'C')) && ! ((cc0 == ';') && (cc1 == 'W')) ){
          zz = false;
          stri = 0;
          cc = ucpInBuff[uipLines[uiI]];
          cc0 = ucpInBuff[uipLines[uiI] + 1];
          while ( cc != 0x0D ){
            if ( ((cc == ';') && (cc0 == 'Y')) ){
              CurRow = RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
              OutChar('F');
              OutChar(';');
              OutChar('Y');
              //StrFmt(b, "%d", ARRAYOFCONST((CurRow)));
              sprintf(b, "%d", CurRow);
              k = 0;
              while ( b[k] != 0 ){
                OutChar(b[k]);
                k++;
              };
              OutChar(0x0D);
              OutChar(0x0A);
            };
            if ( ((cc == ';') && (cc0 == 'X')) ){
              CurCol = RowsP(ucpInBuff + uipLines[uiI] + stri + 2);
              zz = true;
            };
            stri++;
            cc = ucpInBuff[uipLines[uiI] + stri];
            cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
          };
          if ( ( SectionsH[SectionIndex].BeginR <= CurCol ) && ( CurCol <= SectionsH[SectionIndex].EndR ) ){
            yy = true;
            if ( zz ){
              for (uiJ=0; uiJ<uiInWidths; uiJ++){
                WidthR = ParseWidth(ucpInBuff + uipLines[uipWidths[uiJ]] + 3, iMin, iMax, iWidth);
                if ( (iMin <= CurCol) && (CurCol <=iMax) ){
                  OutChar('F');
                  OutChar(';');
                  OutChar('W');
                  WidthR = CurrCol + CurCol - SectionsH[SectionIndex].BeginR;
                  //StrFmt(b, "%d %d %d", ARRAYOFCONST((WidthR, WidthR, iWidth)));
                  sprintf(b, "%d %d %d", WidthR, WidthR, iWidth);
                  k = 0;
                  while ( b[k] != 0 ){
                    OutChar(b[k]);
                    k++;
                  };
                  OutChar(0x0D);
                  OutChar(0x0A);
                };
              };
            };
          };
        };
        //
        zz = false;
        if ( yy ){
          stri = 0;
          cc = ucpInBuff[uipLines[uiI]];
          cc0 = ucpInBuff[uipLines[uiI] + 1];
          while ( cc != 0x0D ){
            if ( (cc == ';') && (cc0 == 'Y') ) zz = true;
            if ( (cc == ';') && (cc0 == 'X') ){
              k = 0;
              while ( true ){
                cc1 = ucpInBuff[uipLines[uiI] + 2 + stri + k];
                if ( ! ((0x030 <= cc1) && (cc1 <= 0x039)) ){
                  break;
                } else
                  k++;
              };
              stri = stri + k + 2;
              cc = ucpInBuff[uipLines[uiI] + stri];
              cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              OutChar(';');
              OutChar('X');
              //StrFmt(b, "%d", ARRAYOFCONST((CurrCol + CurCol - SectionsH[SectionIndex].BeginR)));
              sprintf(b, "%d", CurrCol + CurCol - SectionsH[SectionIndex].BeginR);
              k = 0;
              while ( b[k] != 0 ){
                OutChar(b[k]);
                k++;
              };
              zz = true;
            };
            //Request by VALUE
            if ( (cc == ';') && (cc0 == 'K') ){
              kNum = RowsPExact(ucpInBuff + uipLines[uiI] + stri + 2);
              if ( kNum != 0 ){
                k = 0;
                if ( kNum < 0 ) k = 1;
                while ( true ){
                  cc1 = ucpInBuff[uipLines[uiI] + 2 + stri + k];
                  if ( ! ((0x030 <= cc1) && (cc1 <= 0x039)) ){
                    break;
                  } else
                    k++;
                };
                RequestStr = "";
                if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, kNum, SECTION_DATA_REQUEST_BY_VALUE);
                LenRequestStr = RequestStr.Length();
                if ( LenRequestStr > 0 ){
                  OutChar(';');
                  OutChar('K');
                  i = 1;
                  while ( i <= LenRequestStr ){
                    OutChar(RequestStr[i]);
                    i++;
                  };
                };
                stri = stri + k + 2;
                cc = ucpInBuff[uipLines[uiI] + stri];
                cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              };
            };
            //Request by number
            if ( cc == CharByNum ){    //REQUEST_DATA_BY_NUM_SYMBOL
              //Foword 4 sign
              a0 = ucpInBuff[uipLines[uiI] + stri + 1];
              a1 = ucpInBuff[uipLines[uiI] + stri + 2];
              a2 = ucpInBuff[uipLines[uiI] + stri + 3];
              a3 = ucpInBuff[uipLines[uiI] + stri + 4];
              if ( ((0x030 <= a0) && (a0 <= 0x039)) && ((0x030 <= a1) && (a1 <= 0x039)) && ((0x030 <= a2) && (a2 <= 0x039)) && ((0x030 <= a3) && (a3 <= 0x039)) ){
                uiDataIndex = (a0 - 0x030) * 1000 + (a1 - 0x030) * 100 + (a2 - 0x030) * 10 + (a3 - 0x030);
                if (uiDataIndex > 0){ //Begin with 1  !!!!
                  RequestStr = "";
                  if (FOnSylkReportMessage != NULL ) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, uiDataIndex, SECTION_DATA_REQUEST_BY_NUM);
                  LenRequestStr = RequestStr.Length();
                  if ( LenRequestStr > 0 ){
                    i = 1;
                    while ( i <= LenRequestStr ){
                      OutChar(RequestStr[i]);
                      i++;
                    };
                  };
                  stri = stri + 5;
                  cc = ucpInBuff[uipLines[uiI] + stri];
                  cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
                };
              };
            };
            //Request by name
            if ( cc == CharByName ){   //REQUEST_DATA_BY_NAME_SYMBOL
              cFieldName = "";
              cJ = false;
              for (j=1; j<=MAX_LABEL_NAME_LEGTH; j++){
                cI = ucpInBuff[uipLines[uiI] + stri + j];
                if ( cI == CharByName ){
                  cJ = true;
                  break;
                };
                cFieldName = cFieldName + cI;
              };
              if ( cJ ){  //if found
                RequestStr = "";
                if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, (int)(cFieldName.c_str()), SECTION_DATA_REQUEST_BY_NAME);
                LenRequestStr = RequestStr.Length();
                if ( LenRequestStr > 0 ){
                  i = 1;
                  while ( i <= LenRequestStr ){
                    OutChar(RequestStr[i]);
                    i++;
                  };
                };
                stri = stri + j + 1;
                cc = ucpInBuff[uipLines[uiI] + stri];
                cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
              };
            };
            if ( cc == 0x0D ) break;
            OutChar(cc);
            stri++;
            cc = ucpInBuff[uipLines[uiI] + stri];
            cc0 = ucpInBuff[uipLines[uiI] + stri + 1];
          };
          OutChar(0x0D);
          OutChar(0x0A);
        };
        //

        /////////////////////////
        //Request by cell
        /////////////////////////
        if ( zz ){
          stDataRq.iTypeDataRequest = SECTION_DATA_REQUEST_BY_CELL;
          stDataRq.CurrCell.iRow = CurRow;
          stDataRq.CurrCell.iCol = CurrCol + CurCol - SectionsH[SectionIndex].BeginR;
          stDataRq.BlankCell.iRow = CurRow;
          stDataRq.BlankCell.iCol = CurCol;

          RequestStr = "";
          if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, (int)&stDataRq, SECTION_DATA_REQUEST_BY_CELL);
          LenRequestStr = RequestStr.Length();
          if ( LenRequestStr > 0 ){
            i = 1;
            while ( i <= LenRequestStr ){
              OutChar(RequestStr[i]);
              i++;
            };
          };
        };
        //

      };
      CurrCol = CurrCol + SectionsH[SectionIndex].EndR - SectionsH[SectionIndex].BeginR + 1;
      if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_END);
    };
  };
  if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_COMPLIT);
};

//---------------------------------------------------------------------------
void __fastcall TERpt::_PrepareSection(Section &cSection, const AnsiString &cSectionName, const int SectionIndex){
  FoundPar          fppP;
  AnsiString        ExSectionName;
  int               uiI;
  int               LenN;
  AnsiString        Address;
  CellStruct        TopLeft;
  CellStruct        BottomRight;
  cSection.Name = cSectionName;
  ExSectionName = "NN;N" + cSectionName + ";E";
  fppP.bF = false;
  uiI = 0;
  LenN = ExSectionName.Length();
  while (uiI < uiInLines){
    if ( StrLComp(ucpInBuff + uipLines[uiI], ExSectionName.c_str(), LenN) == 0){
      fppP.bF = true;
      fppP.uiP = uiI;
      break;
    };
    uiI++;
  };
  if (fppP.bF){

    Address = ucpInBuff + uipLines[fppP.uiP] + LenN;
    Address.SetLength(uipLines[fppP.uiP + 1] - (uipLines[fppP.uiP] + LenN) - 2);
    TExcelReport::ParseSelEntry(Address, TopLeft, BottomRight);
    if ( FTypeDiraction == tdVerticaly){
      cSection.BeginR = TopLeft.iRow;
      cSection.EndR = BottomRight.iRow;
    } else {
      cSection.BeginR = TopLeft.iCol;
      cSection.EndR = BottomRight.iCol;
    };

    /*
    fppP.bF = false;
    uiI = uipLines[uiI] + LenN;
    while (true){
      if (ucpInBuff[uiI] == ':'){
        fppP.bF = true;
        break;
      };
      if (ucpInBuff[uiI] == 0x0D) break;
      uiI++;
    };
    if (fppP.bF){
      cSection.BeginR = RowsP(ucpInBuff + uipLines[fppP.uiP] + LenN);
      cSection.EndR = RowsP(ucpInBuff + uiI + 1);
    } else {
      cSection.EndR = RowsP(ucpInBuff + uipLines[fppP.uiP] + LenN);
      cSection.BeginR = cSection.EndR;
    };
    */

    cSection.ucUsed = true;
  } else
    cSection.ucUsed = false;
};

//---------------------------------------------------------------------------
void __fastcall TERpt::CloseSections(void){
  int   i;
  for (i=0; i<MAX_SECTION_NUM; i++){
    Sections[i].ucUsed = false;
    SectionsH[i].ucUsed = false;
  };
};


//---------------------------------------------------------------------------
void __fastcall TERpt::OutChar(char cc){
  int uiRW;
  ucpOutBuff[uiOutP] = cc;
  uiOutP++;
  if (uiOutP == FILE_BUFFER){
    if ( FOutStream == NULL ){
      if ( FWriteStreamPtr == NULL){
        WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
      } else {
        uiRW = (*(FWriteStreamPtr))((void *)ucpOutBuff, uiOutP, NULL);
      };
    } else {
      uiRW = FOutStream->Write(ucpOutBuff, uiOutP);
    };
    uiOutP = 0;
    if (FILE_BUFFER != uiRW){
      if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
      //raise Exception.Create('WRITE_EXCEPTION');
    };
  };
};


//---------------------------------------------------------------------------
void __fastcall TERpt::SeekLastNN(FoundPar &fppP){
  int			uiI;
  fppP.bF = false;
  for (uiI = 0; uiI<uiInLines; uiI++){
    if ( strncmp(ucpInBuff + uipLines[uiI], "NN;N", 4) == 0 ){
      if ( !fppP.bF ) {
        fppP.bF = true;
        fppP.uiP = uiI;
      };
      uiDetail = uiI + 1;
    };
  };
};


//---------------------------------------------------------------------------
int __fastcall TERpt::RowsP(char* RegionD){
  int     i, j, k;
  char    a[10];
  char    cc;
  char    Negative;
  for ( i = 0; i<10; i++ ) a[i] = 0;
  i = 0;
  Negative = 0;
  if ( *RegionD == '-' ){
    i = 1;
    Negative = 1;
  };
  j = 0;
  k = 0;
  while ( TRUE ){
    cc = *(RegionD + i);
    if ( ( 0x30 <= cc ) && ( cc <= 0x39 ) ){
      a[k] = cc;
      k++;
    };
    if ( cc == ' ' ) break;
    if ( cc == ':' ) break;
    if ( cc == ';' ) break;
    if ( cc == 0xD ) break;
    i++;
  };
  j = 0;
  i = 0;
  while ( a[i] ){
    j = j + (a[k - 1 - i]-0x30)*pow10(i);
    i++;
  };
  return Negative ? -j : j;
};

//---------------------------------------------------------------------------
int __fastcall TERpt::RowsPExact(char* RegionD){
  int     i, j, k;
  char    a[10];
  char    cc;
  char    Negative;
  for ( i = 0; i<10; i++ ) a[i] = 0;
  i = 0;
  Negative = 0;
  if ( *RegionD == '-' ){
    i = 1;
    Negative = 1;
  };
  j = 0;
  k = 0;
  while ( TRUE ){
    cc = *(RegionD + i);
    if ( ( 0x30 <= cc ) && ( cc <= 0x39 ) ){
      a[k] = cc;
      k++;
    } else break;
    if ( cc == ' ' ) break;
    if ( cc == ':' ) break;
    if ( cc == ';' ) break;
    if ( cc == 0xD ) break;
    i++;
  };
  j = 0;
  i = 0;
  while ( a[i] ){
    j = j + (a[k - 1 - i]-0x30)*pow10(i);
    i++;
  };
  return Negative ? -j : j;
};

//---------------------------------------------------------------------------
int __fastcall TERpt::pow10(int i){
  int j = 1;
  while ( i-- ) j = j * 10;
  return j;
};


//---------------------------------------------------------------------------
AnsiString __fastcall TERpt::GetSectionName(int iIndex){
  return Sections[iIndex].Name;
};

//---------------------------------------------------------------------------
AnsiString __fastcall TERpt::GetSectionNameH(int iIndex){
  return SectionsH[iIndex].Name;
};


//---------------------------------------------------------------------------
void __fastcall TERpt::Execute(){
  switch (FTypeReport){
    case tsrHorizontaly: lpRepBeginHorizontaly(); break;
    case tsrVerticaly  : lpRepBegin();            break;
    case tsrBiDirection: lpRepBeginBiDirection(); break;
  };
};


//---------------------------------------------------------------------------
void __fastcall TERpt::ReportResume(void){
  FTypeReport = tsrVerticaly;
  Resume();
};

//---------------------------------------------------------------------------
void __fastcall TERpt::ReportExecute(void){
  FTypeReport = tsrVerticaly;
  Execute();
};

//---------------------------------------------------------------------------
void __fastcall TERpt::ReportHorizontalyResume(void){
  FTypeReport = tsrHorizontaly;
  Resume();
};

//---------------------------------------------------------------------------
void __fastcall TERpt::ReportHorizontalyExecute(void){
  FTypeReport = tsrHorizontaly;
  Execute();
};

//---------------------------------------------------------------------------
void __fastcall TERpt::BiDirectionResume(void){
  FTypeReport = tsrBiDirection;
  Resume();
};

//---------------------------------------------------------------------------
void __fastcall TERpt::BiDirectionExecute(void){
  FTypeReport = tsrBiDirection;
  Execute();
};


//---------------------------------------------------------------------------
int __fastcall TERpt::PrepareSection(const AnsiString SectionName){
  int Result;
  if (FLastDynSection == MAX_SECTION_NUM){
    if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, 0);
    //Raise Exception.Create('LIMIT_EXCEEDED');
  };
  if (!lWM_REP_SECTION_PREPARE){
    if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_ALLAGIAL_CALL, 0, 0);
    //Raise Exception.Create('ALLAGIAL_CALL');
  };
  Result = FLastDynSection;
  FLastDynSection++;
  _PrepareSection(Sections[Result], SectionName, Result);
  return Result;
};

//---------------------------------------------------------------------------
int __fastcall TERpt::PrepareHorizontalySection(const AnsiString SectionName){
  int Result;
  if (FLastDynSectionH == MAX_SECTION_NUM){
    if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, 0);
    //Raise Exception.Create('LIMIT_EXCEEDED');
  };
  if (!lWM_REP_SECTION_PREPARE){
    if (FOnSylkReportMessage != NULL) FOnSylkReportMessage(this, WM_REP_ALLAGIAL_CALL, 0, 0);
    //Raise Exception.Create('ALLAGIAL_CALL');
  };
  Result = FLastDynSectionH;
  FLastDynSectionH++;
  _PrepareSection(SectionsH[Result], SectionName, Result);
  return Result;
};


//---------------------------------------------------------------------------
void __fastcall TERpt::OutSection(AnsiString SectionName){
  int i;
  if      ( SectionName == "REPORTHEADER" ) _OutSection(true, 1);
  else if ( SectionName == "GROUPHEADER" ) _OutSection(true, 2);
  else if ( SectionName == "SUBGROUPHEADER" ) _OutSection(true, 3);
  else if ( SectionName == "SUBSUBGROUPHEADER" ) _OutSection(true, 4);
  else if ( SectionName == "SUPERSUBGROUPHEADER" ) _OutSection(true, 5);
  else if ( SectionName == "BODY" ) _OutSection(true, 6);
  else if ( SectionName == "SUPERSUBGROUPFOOTER" ) _OutSection(true, 7);
  else if ( SectionName == "SUBSUBGROUPFOOTER" ) _OutSection(true, 8);
  else if ( SectionName == "SUBGROUPFOOTER" ) _OutSection(true, 9);
  else if ( SectionName == "GROUPFOOTER" ) _OutSection(true, 10);
  else if ( SectionName == "REPORTFOOTER" ) _OutSection(true, 11);
  else {
    for (i = 13; i<MAX_SECTION_NUM; i++){
      if (SectionName == Sections[i].Name){
        _OutSection(true, i);
        break;
      };
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TERpt::OutHorizontalySection(AnsiString SectionName){
  int i;
  if      ( SectionName == "H_REPORTHEADER" ) _OutSectionHorizontaly(true, 1);
  else if ( SectionName == "H_GROUPHEADER" ) _OutSectionHorizontaly(true, 2);
  else if ( SectionName == "H_SUBGROUPHEADER" ) _OutSectionHorizontaly(true, 3);
  else if ( SectionName == "H_SUBSUBGROUPHEADER" ) _OutSectionHorizontaly(true, 4);
  else if ( SectionName == "H_SUPERSUBGROUPHEADER" ) _OutSectionHorizontaly(true, 5);
  else if ( SectionName == "H_BODY" ) _OutSectionHorizontaly(true, 6);
  else if ( SectionName == "H_SUPERSUBGROUPFOOTER" ) _OutSectionHorizontaly(true, 7);
  else if ( SectionName == "H_SUBSUBGROUPFOOTER" ) _OutSectionHorizontaly(true, 8);
  else if ( SectionName == "H_SUBGROUPFOOTER" ) _OutSectionHorizontaly(true, 9);
  else if ( SectionName == "H_GROUPFOOTER" ) _OutSectionHorizontaly(true, 10);
  else if ( SectionName == "H_REPORTFOOTER" ) _OutSectionHorizontaly(true, 11);
  else {
    for (i = 13; i<MAX_SECTION_NUM; i++){
      if (SectionName == SectionsH[i].Name){
        _OutSectionHorizontaly(true, i);
        break;
      };
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TERpt::OutSection(int SectionNum){
  _OutSection(true, SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TERpt::OutHorizontalySection(int SectionNum){
  _OutSectionHorizontaly(true, SectionNum);
};


//------------------------------------------------------------------------------
void __GetTmpFileName(char * cpTempFile /*Must be MAX_PATH + 1 length*/){
  memset(cpTempFile, 0, MAX_PATH + 1);
  GetTempPath(MAX_PATH, cpTempFile);
  GetTempFileName(cpTempFile, "", 0, cpTempFile);
};

//---------------------------------------------------------------------------
#pragma package(smart_init)
