//---------------------------------------------------------------------------

#ifndef ERepH
#define ERepH

#include <Classes.hpp>
#include "ExcelReport.h"
#include "CommonType.h"

class TERpt : public TThread
{
private:

  char                FCharByNum;
  char                FCharByName;
  AnsiString          FInputBlank;
  AnsiString          FOutputBlank;

  HANDLE              fhInBlank;
  HANDLE              fhOutBlank;
  int                 uiSizeIn;
  int                 uiOutP;
  char*               ucpInBuff;          //array [0..FILE_BUFFER-1] of Char;
  char*               ucpOutBuff;         //array [0..FILE_BUFFER-1] of char;
  int*                uipLines;
  int                 uiInLines;
  int*                uipWidths;
  int                 uiInWidths;
  int                 uiDetail;
  int                 CurrRow;
  int                 CurrCol;
  AnsiString          cFieldName;
  bool                bCheck;
  AnsiString          FRequestStr;
  AnsiString          FCurrentSection;
  int                 FCurrentSectionNum;
  DataRq              stDataRq;
  TOnReportMessage    FOnSylkReportMessage;
  TStream*            FOutStream;
  TWriteStream        FWriteStreamPtr;
  TStream*            FInStream;
  TWriteStream        FReadStreamPtr;
  TTtypeDiraction     FTypeDiraction;
  int                 FLastDynSection;
  int                 FLastDynSectionH;
  bool                lWM_REP_SECTION_PREPARE;
  TTtypeSylkReport    FTypeReport;
  bool                fhOkIn;
  bool                fhOkOut;

  Section             Sections[MAX_SECTION_NUM];
  Section             SectionsH[MAX_SECTION_NUM];

  int __fastcall ParseWidth(char* RegionD, int &iMin, int &iMax, int &iWidth);

  void __fastcall lpRepBegin(void);
  void __fastcall lpRepBeginHorizontaly(void);
  void __fastcall lpRepBeginBiDirection(void);
  void __fastcall _OutSection(const bool bDefOut, const int SectionIndex);
  void __fastcall _OutSectionHorizontaly(const bool bDefOut, const int SectionIndex);
  void __fastcall _PrepareSection(Section &cSection, const AnsiString &cSectionName, const int SectionIndex);
  void __fastcall CloseSections(void);

  void __fastcall OutChar(char cc);

  void __fastcall SeekLastNN(FoundPar &fppP);

  int __fastcall RowsP(char* RegionD);
  int __fastcall RowsPExact(char* RegionD);
  int __fastcall pow10(int i);

  AnsiString __fastcall GetSectionName(int iIndex);
  AnsiString __fastcall GetSectionNameH(int iIndex);

protected:

  void __fastcall Execute();

public:

  __fastcall TERpt(void);
  __fastcall ~TERpt(void);

  void __fastcall ReportResume(void);
  void __fastcall ReportExecute(void);
  void __fastcall ReportHorizontalyResume(void);
  void __fastcall ReportHorizontalyExecute(void);
  void __fastcall BiDirectionResume(void);
  void __fastcall BiDirectionExecute(void);

  int __fastcall PrepareSection(const AnsiString SectionName);
  int __fastcall PrepareHorizontalySection(const AnsiString SectionName);

  void __fastcall OutSection(AnsiString SectionName);
  void __fastcall OutHorizontalySection(AnsiString SectionName);
  void __fastcall OutSection(int SectionNum);
  void __fastcall OutHorizontalySection(int SectionNum);

  __property bool Check = { read = bCheck, write = bCheck };
  __property AnsiString RequestStr = { read = FRequestStr, write = FRequestStr };

  __property AnsiString CurrentSection = { read = FCurrentSection };
  __property int CurrentSectionNum = { read = FCurrentSectionNum };

  __property TTtypeDiraction TypeDiraction = { read = FTypeDiraction, write = FTypeDiraction, default = tdVerticaly };
  __property TTtypeSylkReport TypeReport = { read = FTypeReport };

  __property AnsiString InputBlank = { read = FInputBlank, write = FInputBlank };
  __property TStream * InputStream = { read = FInStream, write = FInStream };
  __property TWriteStream ReadStreamPtr = { read = FReadStreamPtr, write = FReadStreamPtr };

  __property AnsiString OutputBlank = { read = FOutputBlank, write = FOutputBlank };
  __property TStream * OutStream = { read = FOutStream, write = FOutStream };
  __property TWriteStream WriteStreamPtr = { read = FWriteStreamPtr, write = FWriteStreamPtr };

  __property char CharByNum = { read = FCharByNum, write = FCharByNum, default = REQUEST_DATA_BY_NUM_SYMBOL_FOR_SYLK }; //&0001
  __property char CharByName = { read = FCharByName, write = FCharByName, default = REQUEST_DATA_BY_NAME_SYMBOL }; //~name~

  __property TOnReportMessage OnSylkReportMessage = { read = FOnSylkReportMessage, write = FOnSylkReportMessage };

  __property AnsiString SectionName[int iIndex] = { read = GetSectionName };
  __property AnsiString SectionNameH[int iIndex] = { read = GetSectionNameH };

};

//---------------------------------------------------------------------------
#endif
