//---------------------------------------------------------------------------

#ifndef ExcelReportH
#define ExcelReportH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "SSmrtRep.h"
#include "CommonType.h"
#include "Excel_2K.h"

//---------------------------------------------------------------------------
class  TCoInit
{
public:

  __fastcall TCoInit(void){
    CoInitialize(NULL);
  };

  __fastcall ~TCoInit(void){
    CoUninitialize();
  };

};

//---------------------------------------------------------------------------
class PACKAGE TExcelReport : public TReportAbstract
{
private:

  Excel_2k::ExcelApplication*     FExcel;
  Excel_2k::ExcelWorkbookPtr      FCurrentWorkBook;
  Excel_2k::ExcelWorksheetPtr     FCurrentWorkSheet;
  Excel_2k::ExcelWorkbookPtr      FReportWorkBook;
  Excel_2k::ExcelWorksheetPtr     FReportSheet;

  PServerData         FServerData;
  AnsiString          FMaket;
  AnsiString          FOutBook;
  int                 FCurrRow; //LongWord;
  int                 FCurrCol; //LongWord;
  TExcelReportSectionInfo  FSectionsV[MAX_SECTION_NUM];
  TExcelReportSectionInfo  FSectionsH[MAX_SECTION_NUM];
  AnsiString          FCurrentSection;
  int                 FCurrentSectionNum;
  AnsiString          FInputSheet;
  AnsiString          FOutputSheet;
  char                FCharByNum;
  char                FCharByName;
  TTtypeDiraction     FTypeDiraction;
  int                 FLastDynSection;
  int                 FLastDynSectionH;
  bool                lWM_REP_SECTION_PREPARE;
  AnsiString          FRemoteMachineName;
  TConnectKind        FConnectKind;

  bool __fastcall ActivateComObject(void);
  bool __fastcall OpenInputBlank(void);

  void __fastcall StartReportV(void);
  void __fastcall PrepareSectionV(AnsiString SectionName, int SectionNum);
  void __fastcall OutSectionV(AnsiString SectionName, bool bOut, int SectionNum);
  void __fastcall CloseSectionsV(void);

  void __fastcall StartReportH(void);
  void __fastcall PrepareSectionH(AnsiString SectionName, int SectionNum);
  void __fastcall OutSectionH(AnsiString SectionName, bool bOut, int SectionNum);
  void __fastcall CloseSectionsH(void);

  void __fastcall StartBiDirectionReport(void);
  TConnectKind __fastcall GetConnectKind(void);
  void __fastcall SetConnectKind(const TConnectKind Value);

protected:

  AnsiString __fastcall GetInputBlank(void){ return FMaket; };
  void __fastcall SetInputBlank(const AnsiString Value){ FMaket = Value; };

  AnsiString __fastcall GetInputSheet(void){ return FInputSheet; };
  void __fastcall SetInputSheet(const AnsiString Value){ FInputSheet = Value; };

  AnsiString __fastcall GetOutputBlank(void){ return FOutBook; };
  void __fastcall SetOutputBlank(const AnsiString Value){ FOutBook = Value; };

  AnsiString __fastcall GetOutputSheet(void){ return FOutputSheet; };
  void __fastcall SetOutputSheet(AnsiString Value){ FOutputSheet = Value; };

  char __fastcall GetCharByNum(void){ return FCharByNum; };
  void __fastcall SetCharByNum(const char Value){ FCharByNum = Value; };

  virtual char __fastcall GetCharByName(void){ return FCharByName; };
  virtual void __fastcall SetCharByName(const char Value){ FCharByName = Value; };


  AnsiString __fastcall GetCurrentSection(void);
  int __fastcall GetCurrentSectionNum(void);
  TTtypeDiraction __fastcall GetTypeDiraction(void);

  __property PServerData ServerData = { read = FServerData, write = FServerData };

public:

  __fastcall TExcelReport(TComponent* Owner);
  __fastcall ~TExcelReport(void);

  static AnsiString __fastcall ParseSelEntry(AnsiString& Sel, CellStruct& TopLeft, CellStruct& BottomRight);

  void __fastcall ReportResume(void);
  void __fastcall ReportExecute(void);
  void __fastcall ReportHorizontalyResume(void);
  void __fastcall ReportHorizontalyExecute(void);
  void __fastcall BiDirectionResume(void);
  void __fastcall BiDirectionExecute(void);
  int __fastcall PrepareSection(const AnsiString SectionName);
  int __fastcall PrepareHorizontalySection(const AnsiString SectionName);

  void __fastcall OutSection(AnsiString SectionName);
  void __fastcall OutHorizontalySection(AnsiString SectionName);
  void __fastcall OutSection(int SectionNum);
  void __fastcall OutHorizontalySection(int SectionNum);

  __property Excel_2k::ExcelApplication* Excel = { read = FExcel };
  __property Excel_2k::ExcelWorksheetPtr ReportSheet = { read = FReportSheet };

__published:

  //__property AnsiString RemoteMachineName = { read = FRemoteMachineName, write = FRemoteMachineName };
  __property TConnectKind ConnectKind = { read = GetConnectKind, write = SetConnectKind };

  //__property AnsiString InputBlank = { read = FMaket, write = FMaket };
  //__property AnsiString InputSheet = { read = FInputSheet, write = FInputSheet };
  //__property AnsiString OutputBlank = { read = FOutBook, write = FOutBook };
  //__property AnsiString OutputSheet = { read = FOutputSheet, write = FOutputSheet };
  //__property char CharByNum = { read = FCharByNum, write = FCharByNum, default = REQUEST_DATA_BY_NUM_SYMBOL }; //#0001
  //__property char CharByName = { read = FCharByName, write = FCharByName, default = REQUEST_DATA_BY_NAME_SYMBOL }; //~name~

  __property InputBlank;
  __property InputSheet;
  __property OutputBlank;
  __property OutputSheet;
  __property CharByNum;
  __property CharByName;

  __property OnStartReport;
  __property OnEndReport;
  __property OnReportError;
  __property OnMoveTop;
  __property OnMoveNext;
  __property OnSectionBegin;
  __property OnSectionEnd;
  __property OnSectionComplit;
  __property OnSectionCheck;
  __property OnDataRequest;
  __property OnRequestByName;
  __property OnRequestByNum;
  __property OnSectionPrepare;

};

AnsiString __fastcall ToA1(const CellStruct& sCell);

int __fastcall GetNumber(AnsiString& AString);
int __fastcall RScan(const AnsiString& S, char Chr);
int __fastcall LScan(const AnsiString& S, char Chr, int StartPos);
AnsiString __fastcall StripQuotation(const AnsiString& AString);

//---------------------------------------------------------------------------
#endif
