//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ReportContainer.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TReportContainer *)
{
  new TReportContainer(NULL);
}
//---------------------------------------------------------------------------
__fastcall TReportContainer::TReportContainer(TComponent* Owner)
  : TComponent(Owner)
{
  FReport = NULL;
}


//---------------------------------------------------------------------------
TTtypeDiraction __fastcall TReportContainer::GetTypeDiraction(void){
  TTtypeDiraction Result;
  Result = tdNotDefined;
  if (FReport != NULL) Result = FReport->TypeDiraction;
  return Result;
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportPrepare(void){

  if (FReport != NULL){

    FOldOnStartReport     =  FReport->OnStartReport;
    FOldOnEndReport       =  FReport->OnEndReport;
    FOldOnReportError     =  FReport->OnReportError;
    FOldOnMoveTop         =  FReport->OnMoveTop;
    FOldOnMoveNext        =  FReport->OnMoveNext;
    FOldOnSectionBegin    =  FReport->OnSectionBegin;
    FOldOnSectionEnd      =  FReport->OnSectionEnd;
    FOldOnSectionComplit  =  FReport->OnSectionComplit;
    FOldOnSectionCheck    =  FReport->OnSectionCheck;
    FOldOnDataRequest     =  FReport->OnDataRequest;
    FOldOnRequestByName   =  FReport->OnRequestByName;
    FOldOnRequestByNum    =  FReport->OnRequestByNum;
    FOldOnSectionPrepare  =  FReport->OnSectionPrepare;

    if (FOnStartReport    != NULL) FReport->OnStartReport     = FOnStartReport;
    if (FOnEndReport      != NULL) FReport->OnEndReport       = FOnEndReport;
    if (FOnReportError    != NULL) FReport->OnReportError     = FOnReportError;
    if (FOnMoveTop        != NULL) FReport->OnMoveTop         = FOnMoveTop;
    if (FOnMoveNext       != NULL) FReport->OnMoveNext        = FOnMoveNext;
    if (FOnSectionBegin   != NULL) FReport->OnSectionBegin    = FOnSectionBegin;
    if (FOnSectionEnd     != NULL) FReport->OnSectionEnd      = FOnSectionEnd;
    if (FOnSectionComplit != NULL) FReport->OnSectionComplit  = FOnSectionComplit;
    if (FOnSectionCheck   != NULL) FReport->OnSectionCheck    = FOnSectionCheck;
    if (FOnDataRequest    != NULL) FReport->OnDataRequest     = FOnDataRequest;
    if (FOnRequestByName  != NULL) FReport->OnRequestByName   = FOnRequestByName;
    if (FOnRequestByNum   != NULL) FReport->OnRequestByNum    = FOnRequestByNum;
    if (FOnSectionPrepare != NULL) FReport->OnSectionPrepare  = FOnSectionPrepare;

  };

};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportUnPrepare(void){

  if (FReport != NULL){

    FReport->OnStartReport     = FOldOnStartReport;
    FReport->OnEndReport       = FOldOnEndReport;
    FReport->OnReportError     = FOldOnReportError;
    FReport->OnMoveTop         = FOldOnMoveTop;
    FReport->OnMoveNext        = FOldOnMoveNext;
    FReport->OnSectionBegin    = FOldOnSectionBegin;
    FReport->OnSectionEnd      = FOldOnSectionEnd;
    FReport->OnSectionComplit  = FOldOnSectionComplit;
    FReport->OnSectionCheck    = FOldOnSectionCheck;
    FReport->OnDataRequest     = FOldOnDataRequest;
    FReport->OnRequestByName   = FOldOnRequestByName;
    FReport->OnRequestByNum    = FOldOnRequestByNum;
    FReport->OnSectionPrepare  = FOldOnSectionPrepare;

  };

};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportUnPrepareNotify(TObject * Sender){
  ReportUnPrepare();
};

//---------------------------------------------------------------------------
AnsiString __fastcall TReportContainer::GetCurrentSection(void){
  AnsiString Result = "";
  if (FReport != NULL) Result = FReport->CurrentSection;
  return Result;
};

//---------------------------------------------------------------------------
int __fastcall TReportContainer::GetCurrentSectionNum(void){
  int Result = -1;
  if (FReport != NULL) Result = FReport->CurrentSectionNum;
  return Result;
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportResume(void){
  ReportPrepare();
  TRThread* FThread = new TRThread(true);
  FThread->FreeOnTerminate = true;
  if (FReport != NULL) FThread->OnExecute = FReport->ReportExecute;
  FThread->OnTerminate = ReportUnPrepareNotify;
  FThread->Resume();
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportExecute(void){
  ReportPrepare();
  if (FReport != NULL) FReport->ReportExecute();
  ReportUnPrepare();
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportHorizontalyResume(void){
  TRThread* FThread;
  ReportPrepare();
  FThread = new TRThread(true);
  FThread->FreeOnTerminate = true;
  if (FReport != NULL) FThread->OnExecute = FReport->ReportHorizontalyExecute;
  FThread->OnTerminate = ReportUnPrepareNotify;
  FThread->Resume();
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::ReportHorizontalyExecute(void){
  ReportPrepare();
  if (FReport != NULL) FReport->ReportHorizontalyExecute();
  ReportUnPrepare();
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::BiDirectionResume(void){
  TRThread * FThread;
  ReportPrepare();
  FThread = new TRThread(true);
  FThread->FreeOnTerminate = true;
  if (FReport != NULL) FThread->OnExecute = FReport->BiDirectionExecute;
  FThread->OnTerminate = ReportUnPrepareNotify;
  FThread->Resume();
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::BiDirectionExecute(void){
  ReportPrepare();
  if (FReport != NULL) FReport->BiDirectionExecute();
  ReportUnPrepare();
};

//---------------------------------------------------------------------------
int __fastcall TReportContainer::PrepareSection(const AnsiString SectionName){
  int Result = 0;
  if (FReport != NULL) Result = FReport->PrepareSection(SectionName);
  return Result;
};

//---------------------------------------------------------------------------
int __fastcall TReportContainer::PrepareHorizontalySection(const AnsiString SectionName){
  int Result = 0;
  if (FReport != NULL) Result = FReport->PrepareHorizontalySection(SectionName);
  return Result;
};


//---------------------------------------------------------------------------
void __fastcall TReportContainer::OutSection(const AnsiString SectionName){
  if (FReport != NULL) FReport->OutSection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::OutHorizontalySection(const AnsiString SectionName){
  if (FReport != NULL) FReport->OutHorizontalySection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::OutSection(int SectionNum){
  if (FReport != NULL) FReport->OutSection(SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TReportContainer::OutHorizontalySection(int SectionNum){
  if (FReport != NULL) FReport->OutHorizontalySection(SectionNum);
};


//---------------------------------------------------------------------------
