//---------------------------------------------------------------------------

#ifndef ReportContainerH
#define ReportContainerH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "CommonType.h"
//---------------------------------------------------------------------------
class PACKAGE TReportContainer : public TComponent
{
private:

  TReportAbstract *             FReport;

  TNotifyEvent                  FOnStartReport;
  TNotifyEvent                  FOnEndReport;
  TOnRepError                   FOnReportError;
  TOnCheck                      FOnMoveTop;
  TOnCheck                      FOnMoveNext;
  TOnBeginEndSectionEvent       FOnSectionBegin;
  TOnBeginEndSectionEvent       FOnSectionEnd;
  TOnBeginEndSectionEvent       FOnSectionComplit;
  TOnSectionCheck               FOnSectionCheck;
  TOnDataRequest                FOnDataRequest;
  TOnDataRequestByName          FOnRequestByName;
  TOnDataRequestByNum           FOnRequestByNum;
  TNotifyEvent                  FOnSectionPrepare;

  TNotifyEvent                  FOldOnStartReport;
  TNotifyEvent                  FOldOnEndReport;
  TOnRepError                   FOldOnReportError;
  TOnCheck                      FOldOnMoveTop;
  TOnCheck                      FOldOnMoveNext;
  TOnBeginEndSectionEvent       FOldOnSectionBegin;
  TOnBeginEndSectionEvent       FOldOnSectionEnd;
  TOnBeginEndSectionEvent       FOldOnSectionComplit;
  TOnSectionCheck               FOldOnSectionCheck;
  TOnDataRequest                FOldOnDataRequest;
  TOnDataRequestByName          FOldOnRequestByName;
  TOnDataRequestByNum           FOldOnRequestByNum;
  TNotifyEvent                  FOldOnSectionPrepare;

  TTtypeDiraction __fastcall GetTypeDiraction(void);
  void __fastcall ReportPrepare(void);
  void __fastcall ReportUnPrepare(void);
  void __fastcall ReportUnPrepareNotify(TObject * Sender);
  AnsiString __fastcall GetCurrentSection(void);
  int __fastcall GetCurrentSectionNum(void);

protected:
public:

  __fastcall TReportContainer(TComponent* Owner);

  void __fastcall ReportResume(void);
  void __fastcall ReportExecute(void);
  void __fastcall ReportHorizontalyResume(void);
  void __fastcall ReportHorizontalyExecute(void);
  void __fastcall BiDirectionResume(void);
  void __fastcall BiDirectionExecute(void);
  int __fastcall PrepareSection(const AnsiString SectionName);
  int __fastcall PrepareHorizontalySection(const AnsiString SectionName);

  void __fastcall OutSection(const AnsiString SectionName);
  void __fastcall OutHorizontalySection(const AnsiString SectionName);
  void __fastcall OutSection(int SectionNum);
  void __fastcall OutHorizontalySection(int SectionNum);

  __property AnsiString CurrentSection = { read = GetCurrentSection };
  __property int CurrentSectionNum = { read = GetCurrentSectionNum };

  __property TTtypeDiraction TypeDiraction = { read = GetTypeDiraction };

  __property TNotifyEvent OnOldStartReport = { read = FOldOnStartReport };
  __property TNotifyEvent OnOldEndReport = { read = FOldOnEndReport };
  __property TOnRepError OnOldReportError = { read = FOldOnReportError };
  __property TOnCheck OnOldMoveTop = { read = FOldOnMoveTop, };
  __property TOnCheck OnOldMoveNext = { read = FOldOnMoveNext };
  __property TOnBeginEndSectionEvent OnOldSectionBegin = { read = FOldOnSectionBegin };
  __property TOnBeginEndSectionEvent OnOldSectionEnd = { read = FOldOnSectionEnd };
  __property TOnBeginEndSectionEvent OnOldSectionComplit = { read = FOldOnSectionComplit };
  __property TOnSectionCheck OnOldSectionCheck = { read = FOldOnSectionCheck };
  __property TOnDataRequest OnOldDataRequest = { read = FOldOnDataRequest };
  __property TOnDataRequestByName OnOldRequestByName = { read = FOldOnRequestByName };
  __property TOnDataRequestByNum OnOldRequestByNum = { read = FOldOnRequestByNum };
  __property TNotifyEvent OnOldSectionPrepare = { read = FOldOnSectionPrepare };

__published:

  __property TReportAbstract* Report = { read = FReport, write = FReport };

  __property TNotifyEvent OnStartReport = { read = FOnStartReport, write = FOnStartReport };
  __property TNotifyEvent OnEndReport = { read = FOnEndReport, write = FOnEndReport };
  __property TOnRepError OnReportError = { read = FOnReportError, write = FOnReportError };
  __property TOnCheck OnMoveTop = { read = FOnMoveTop, write = FOnMoveTop };
  __property TOnCheck OnMoveNext = { read = FOnMoveNext, write = FOnMoveNext };
  __property TOnBeginEndSectionEvent OnSectionBegin = { read = FOnSectionBegin, write = FOnSectionBegin };
  __property TOnBeginEndSectionEvent OnSectionEnd = { read = FOnSectionEnd, write = FOnSectionEnd };
  __property TOnBeginEndSectionEvent OnSectionComplit = { read = FOnSectionComplit, write = FOnSectionComplit };
  __property TOnSectionCheck OnSectionCheck = { read = FOnSectionCheck, write = FOnSectionCheck };
  __property TOnDataRequest OnDataRequest = { read = FOnDataRequest, write = FOnDataRequest };
  __property TOnDataRequestByName OnRequestByName = { read = FOnRequestByName, write = FOnRequestByName };
  __property TOnDataRequestByNum OnRequestByNum = { read = FOnRequestByNum, write = FOnRequestByNum };
  __property TNotifyEvent OnSectionPrepare = { read = FOnSectionPrepare, write = FOnSectionPrepare };
  
};
//---------------------------------------------------------------------------
#endif
