//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <string.h>
#include "SSmrtRep.h"

//---------------------------------------------------------------------------
__fastcall TSmartRpt::TSmartRpt(void) : TThread(true){
  this->Priority = tpNormal;
  FreeOnTerminate = false;
  FOnSmartReportMessage = NULL;
  FOutStream = NULL;
  WriteStreamPtr = NULL;
  FInStream = NULL;
  FReadStreamPtr = NULL;
  FLastDynSection = 13;
  FPrepareDynSection = false;
  lWM_REP_SECTION_PREPARE = false;
  ucpInBuff = StrAlloc(FILE_BUFFER);
  ucpOutBuff = StrAlloc(FILE_BUFFER);
  SectionNames[FILE_HEADER  		   ] = "FILEHEADER";
  SectionNames[REPORT_HEADER 			 ] = "REPORTHEADER";
  SectionNames[GROUP_HEADER				 ] = "GROUPHEADER";
  SectionNames[SUBGROUP_HEADER		 ] = "SUBGROUPHEADER";
  SectionNames[SUBSUBGROUP_HEADER	 ] = "SUBSUBGROUPHEADER";
  SectionNames[SUPERSUBGROUP_HEADER] = "SUPERSUBGROUPHEADER";
  SectionNames[BODY								 ] = "BODY";
  SectionNames[SUPERSUBGROUP_FOOTER] = "SUPERSUBGROUPFOOTER";
  SectionNames[SUBSUBGROUP_FOOTER	 ] = "SUBSUBGROUPFOOTER";
  SectionNames[SUBGROUP_FOOTER		 ] = "SUBGROUPFOOTER";
  SectionNames[GROUP_FOOTER				 ] = "GROUPFOOTER";
  SectionNames[REPORT_FOOTER			 ] = "REPORTFOOTER";
  SectionNames[FILE_FOOTER  		   ] = "FILEFOOTER";
};

//---------------------------------------------------------------------------
__fastcall TSmartRpt::~TSmartRpt(void){
  StrDispose(ucpInBuff);
  StrDispose(ucpOutBuff);
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::Build(void){
  Execute();
};

//---------------------------------------------------------------------------
AnsiString __fastcall TSmartRpt::GetSectionName(int Index){
  return Sections[Index].Name;
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::Execute(){
  unsigned int				      uiJ, uiRW;
  FoundPar						      fppP;
  FoundPar						      fppQ;
  bool                      CreateOK;
  fhOkIn = false;
  fhOkOut = false;
  if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_START_REPORT, 0, 0);
  CreateOK = true;
  if ( ucpIn != "" ){
    fhInBlank = CreateFile(ucpIn.c_str(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, (LPSECURITY_ATTRIBUTES)NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
    CreateOK = (fhInBlank != INVALID_HANDLE_VALUE);
    fhOkIn = true;
  } else {
    CreateOK = ( (FInStream != NULL) || (FReadStreamPtr != NULL) );
  };
  if ( CreateOK ){
    CreateOK = true;
    if ( ucpOut != "" ){
      fhOutBlank = CreateFile(ucpOut.c_str(), GENERIC_READ | GENERIC_WRITE, 0, (LPSECURITY_ATTRIBUTES)NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
      CreateOK = (fhOutBlank != INVALID_HANDLE_VALUE);
      fhOkOut = true;
    } else {
      CreateOK = ( (FOutStream != NULL) || (FWriteStreamPtr != NULL) );
    };
		if ( CreateOK ){
      CreateOK = false;
      uiSizeIn = 0;
      if ( fhOkIn ){
        SetFilePointer(fhInBlank, 0x0, NULL, FILE_BEGIN);
        CreateOK = ReadFile(fhInBlank, (LPVOID)ucpInBuff, FILE_BUFFER, (LPDWORD)&uiSizeIn, NULL);
      } else {
        if ( FInStream != NULL ){
          FInStream->Seek(0, soFromBeginning);
          uiSizeIn = FInStream->Read((LPVOID)ucpInBuff, FILE_BUFFER);
          CreateOK = true;
        } else {
          if ( FReadStreamPtr != NULL ){
            uiSizeIn = (*FReadStreamPtr)(ucpInBuff, FILE_BUFFER, NULL);
            CreateOK = true;
          };
        };
      };
      if ( CreateOK ){
        if ( uiSizeIn ){
          uiOutP = 0;
          try {
            SeekTextWithBrackets("#BEGIN QREPORT", &fppP);
            SeekTextWithBrackets("#END QREPORT", &fppQ);
            if (fppP.bF){
              if (fppQ.bF){
                if (fppP.bFL){
                  if (fppP.bFR){
                    if (fppQ.bFL){
                      if (fppQ.bFR){
                        if ( fppP.uiZ <= fppQ.uiP ){
                          Sections[0].Name = "RTF HEADER";
                          Sections[0].StartPosition = 0;
                          Sections[0].Length = fppP.uiP;
                          PrepareSection("REPORT HEADER",       	1);
                          PrepareSection("GROUP HEADER",        	2);
                          PrepareSection("SUBGROUP HEADER",     	3);
                          PrepareSection("SUBSUBGROUP HEADER",  	4);
                          PrepareSection("SUPERSUBGROUP HEADER",	5);
                          PrepareSection("BODY",                	6);
                          PrepareSection("SUPERSUBGROUP FOOTER",	7);
                          PrepareSection("SUBSUBGROUP FOOTER",  	8);
                          PrepareSection("SUBGROUP FOOTER",     	9);
                          PrepareSection("GROUP FOOTER",        	10);
                          PrepareSection("REPORT FOOTER",       	11);
                          Sections[12].Name = "RTF FOOTER";
                          Sections[12].StartPosition = fppQ.uiZ;
                          Sections[12].Length = uiSizeIn - fppQ.uiZ;
                          OutSection(TRUE, 0);
                          lWM_REP_SECTION_PREPARE = true;
                          if (FOnSmartReportMessage != NULL) FOnSmartReportMessage(this, WM_REP_SECTION_PREPARE, 0, 0);
                          lWM_REP_SECTION_PREPARE = false;
                          OutSection(TRUE, 1);
                          uiJ = 1;
                          bCheck = false;
                          if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_MOVE, uiJ, MOVE_TOP);
                          while ( !bCheck ){
                            OutSection(FALSE, 2);
                            OutSection(FALSE, 3);
                            OutSection(FALSE, 4);
                            OutSection(FALSE, 5);
                            OutSection(TRUE,  6);
                            OutSection(FALSE, 7);
                            OutSection(FALSE, 8);
                            OutSection(FALSE, 9);
                            OutSection(FALSE, 10);
                            bCheck = false;
                            if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_MOVE, ++uiJ, MOVE_NEXT);
                          };
                          OutSection(TRUE,  11);
                          OutSection(TRUE,  12);
                          if ( uiOutP ){
                            if ( FOutStream == NULL ){
                              if ( FWriteStreamPtr == NULL ){
                                WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
                              } else {
                                uiRW = (*(FWriteStreamPtr))((void*)ucpOutBuff, uiOutP, NULL);
                              };
                            } else {
                              uiRW = FOutStream->Write(ucpOutBuff, uiOutP);
                            };
                            if (uiOutP != uiRW){
                              if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
                              RaiseException(WRITE_EXCEPTION, 0, 0, NULL);
                            };
                            uiOutP = 0;
                          };
                        } else {
                          if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_BEGIN_QREPORT_AFTER_END_QREPORT);
                          RaiseException(SECTION_EXCEPTION, 0, 0, NULL);
                        };
                      } else {
                        if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_END_QREPORT_WITHOUT_RIGHT_RTF_TAG);
                        RaiseException(SECTION_EXCEPTION, 0, 0, NULL);
                      };
                    } else {
                      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_END_QREPORT_WITHOUT_LEFT_RTF_TAG);
                      RaiseException(SECTION_EXCEPTION, 0, 0, NULL);
                    };
                  } else {
                    if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_BEGIN_QREPORT_WITHOUT_RIGHT_RTF_TAG);
                    RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
                  };
                } else {
                  if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_BEGIN_QREPORT_WITHOUT_LEFT_RTF_TAG);
                  RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
                };
              } else{
                if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_NOT_END_QREPORT);
                RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
              };
            } else {
              if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, SECTION_ERROR_NOT_BEGIN_QREPORT);
              RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
            };
          } catch (...) {
          };
        } else if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_READ_ERROR, 0, READ_ERROR_ZERO);
      } else if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_READ_ERROR, 0, READ_ERROR);
      if ( fhOkOut ) CloseHandle(fhOutBlank);
    } else if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_CREATE_ERROR, 0, 0);
    if ( fhOkIn ) CloseHandle(fhInBlank);
  } else if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_OPEN_ERROR, 0, 0);
  if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_END_REPORT, 0, 0);
};

//---------------------------------------------------------------------------
int __fastcall TSmartRpt::PrepareSection(const AnsiString SectionName){
  int Ret;
  if (FLastDynSection > MAX_SECTION_NUM){
    if (FOnSmartReportMessage != NULL) FOnSmartReportMessage(this, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, 0);
    RaiseException(LIMIT_EXCEEDED, 0, NULL, NULL);
  };
  if ( ! lWM_REP_SECTION_PREPARE ){
    if (FOnSmartReportMessage != NULL) FOnSmartReportMessage(this, WM_REP_ALLAGIAL_CALL, 0, 0);
    RaiseException(ALLAGIAL_CALL, 0, NULL, NULL);
  };
  Ret = FLastDynSection;
  FLastDynSection++;
  FPrepareDynSection = true;
  PrepareSection(SectionName, Ret);
  FPrepareDynSection = false;
  return Ret;
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::PrepareSection(const AnsiString SectionName, const int SectionIndex){
  FoundPar						fppP;
  FoundPar						fppQ;
  Sections[SectionIndex].Name = SectionName;
  Sections[SectionIndex].StartPosition = 0;
  Sections[SectionIndex].Length = 0;
  if ( FPrepareDynSection ){
    SeekTextWithBrackets(AnsiString("#BEGIN SECTION ") + AnsiString("\\") + AnsiString("lquote ") + SectionName + AnsiString("\\rquote"), &fppP);
    SeekTextWithBrackets(AnsiString("#END SECTION ") + AnsiString("\\") + AnsiString("lquote ") + SectionName + AnsiString("\\rquote"), &fppQ);
    FPrepareDynSection = false;
  } else {
    SeekTextWithBrackets("#BEGIN " + SectionName, &fppP);
    SeekTextWithBrackets("#END " + SectionName, &fppQ);
  };
  if ( (fppP.bF && fppQ.bF) && (fppP.bFL && fppQ.bFL) && (fppP.bFR && fppQ.bFR) ){
    if (fppQ.uiP >=  fppP.uiZ){
      Sections[SectionIndex].StartPosition = fppP.uiZ;
      Sections[SectionIndex].Length = fppQ.uiP - fppP.uiZ;
    } else {
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 8);  //*_END_*_BEFORE_BEGIN_*
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
  } else {
    if ( fppQ.bF && (!fppQ.bFL) && (!fppQ.bFR) ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 0);   //*_END_*_WITHOUT_LEFT_AND_RIGHT_RTF_TAG
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppQ.bF && (!fppQ.bFL) && fppQ.bFR ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 1);  //*_END_*_WITHOUT_LEFT_RTF_TAG
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppQ.bF && fppQ.bFL && (!fppQ.bFR) ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 2);  //*_END_*_WITHOUT_RIGHT_RTF_TAG
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppP.bF && (!fppP.bFL) && (!fppP.bFR) ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 3);  //*_BEGIN_*_WITHOUT_LEFT_AND_RIGHT_RTF_TAG
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppP.bF && (!fppP.bFL) && fppP.bFR ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 4);  //*_BEGIN_*_WITHOUT_LEFT_RTF_TAG
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppP.bF && fppP.bFL && (!fppP.bFR) ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 5);  //*_BEGIN_*_WITHOUT_RIGHT_RTF_TAG
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppP.bF && (!fppQ.bF) && (fppP.bFL && fppQ.bFL) && (fppP.bFR && fppQ.bFR) ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 6);  //*_BEGIN_*_WITHOUT_END_*
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
    if ( fppP.bF && (!fppQ.bF) && (fppP.bFL && fppQ.bFL) && (fppP.bFR && fppQ.bFR) ){
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_SECTION_ERROR, 0, (NEW_SECTION_ERROR_START + (SectionIndex - 1) * SECTION_ERROR_NUMS) + 7);  //*_END_*_WITHOUT_BEGIN_*
      RaiseException(SECTION_EXCEPTION, 0, NULL, NULL);
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::SeekTextWithBrackets(const AnsiString ucpW, FoundPar * fppP){
  unsigned int			uiI;
  int               LenW;
  char *            cpW;
  fppP->bF = false;
  cpW = ucpW.c_str();
  LenW = ucpW.Length();
  for (uiI = 0; uiI < uiSizeIn; uiI++){
    if ( strncmp((char*)(ucpInBuff+uiI), cpW, LenW) == 0 ){
      fppP->bF = true;
      break;
    };
  };
  fppP->bFL = true;
  fppP->bFR = true;
  fppP->uiP = uiI;
  fppP->uiZ = uiI + ucpW.Length();
  if ( fppP->bF ){
    while( true ){
      if ( fppP->uiP ){
        fppP->uiP--;
        if( *(ucpInBuff+fppP->uiP) == RTF_SECTION_BEGIN_BREAKED )	break;  //{
        if( *(ucpInBuff+fppP->uiP) == RTF_SECTION_END_BREAKED ){           //}
          fppP->bFL = false;
          break;
        };
      } else {
        fppP->bFL = false;
        break;
      };
    };
    while(true){
      if (fppP->uiZ < uiSizeIn){
        fppP->uiZ++;
        if ( *(ucpInBuff+fppP->uiZ) == RTF_SECTION_END_BREAKED ){    //}
          fppP->uiZ++;
          break;
        };
        if ( *(ucpInBuff+fppP->uiZ) == RTF_SECTION_BEGIN_BREAKED ){  //{
          fppP->bFR = false;
          break;
        };
      } else {
        fppP->bFR = false;
        break;
      };
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::OutSection(const AnsiString SectionName){
  int i;
  if      ( SectionName == "REPORTHEADER" ) OutSection(TRUE, 1);
  else if ( SectionName == "GROUPHEADER" ) OutSection(TRUE, 2);
  else if ( SectionName == "SUBGROUPHEADER" ) OutSection(TRUE, 3);
  else if ( SectionName == "SUBSUBGROUPHEADER" ) OutSection(TRUE, 4);
  else if ( SectionName == "SUPERSUBGROUPHEADER" ) OutSection(TRUE, 5);
  else if ( SectionName == "BODY" ) OutSection(TRUE, 6);
  else if ( SectionName == "SUPERSUBGROUPFOOTER" ) OutSection(TRUE, 7);
  else if ( SectionName == "SUBSUBGROUPFOOTER" ) OutSection(TRUE, 8);
  else if ( SectionName == "SUBGROUPFOOTER" ) OutSection(TRUE, 9);
  else if ( SectionName == "GROUPFOOTER" ) OutSection(TRUE, 10);
  else if ( SectionName == "REPORTFOOTER" ) OutSection(TRUE, 11);
  else {
    for (i = 13; MAX_SECTION_NUM; i++){
      if (SectionName == Sections[i].Name){
        OutSection(true, i);
        break;
      };
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::OutSection(const int SectionNum){
  OutSection(true, SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TSmartRpt::OutSection(const bool bDefOut, const int SectionIndex){
  int               uiI, uiDataIndex, i, j, uiRW;
  char              cI, a0, a1, a2, a3;
  bool              bJ;
  int               LenRequestStr;
  char *            cpRequestStr;
  if ( SectionIndex < 13 ){
    FCurrentSection = SectionNames[SectionIndex];
  } else {
    FCurrentSection = Sections[SectionIndex].Name;
  };
  FCurrentSectionNum = SectionIndex;
  if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_BEGIN);
  if ( Sections[SectionIndex].Length ){
    bCheck = bDefOut;
    if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_CHECK);
    if ( (SectionIndex == 0) || (SectionIndex == 12) ) bCheck = true;
    if ( bCheck ){
      for (uiI=0; uiI < (int)Sections[SectionIndex].Length; uiI++){
        //Request by number
        if (*(ucpInBuff+Sections[SectionIndex].StartPosition+uiI) == BY_NUM_SYMBOL){    //REQUEST_DATA_BY_NUM_SYMBOL /*@*/
          //Foword 4 sign
          a0 = *(ucpInBuff+Sections[SectionIndex].StartPosition + uiI + 1);
          a1 = *(ucpInBuff+Sections[SectionIndex].StartPosition + uiI + 2);
          a2 = *(ucpInBuff+Sections[SectionIndex].StartPosition + uiI + 3);
          a3 = *(ucpInBuff+Sections[SectionIndex].StartPosition + uiI + 4);
          if ( ((0x30 <= a0) && (a0 <= 0x39)) && ((0x30 <= a1) && (a1 <= 0x39)) && ((0x30 <= a2) && (a2 <= 0x39)) && ((0x30 <= a3) && (a3 <= 0x39)) ){
            uiDataIndex = (a0 - 0x30) * 1000 + (a1 - 0x30) * 100 + (a2 - 0x30) * 10 + (a3 - 0x30);
            if (uiDataIndex){ //Begin with 1  !!!!
              if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, NEW_SECTION_START + SectionIndex, uiDataIndex, SECTION_DATA_REQUEST_BY_NUM);
              i = 0;
              LenRequestStr = RequestStr.Length();
              cpRequestStr = RequestStr.c_str();
              while ( i < LenRequestStr ){
                *(ucpOutBuff+uiOutP++) = cpRequestStr[i++];
                if ( uiOutP == FILE_BUFFER ){
                  if ( FOutStream == NULL ){
                    if ( FWriteStreamPtr == NULL ){
                      WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
                    } else {
                      uiRW = (*(FWriteStreamPtr))((void*)ucpOutBuff, uiOutP, NULL);
                    };
                  } else {
                    uiRW = FOutStream->Write(ucpOutBuff, FILE_BUFFER);
                  };
                  uiOutP = 0;
                  if ((FILE_BUFFER) != uiRW){
                    if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
                    RaiseException(WRITE_EXCEPTION, 0, NULL, NULL);
                  };
                };
              };
              uiI += 5;
            };
          };
        };
        //Request by name
        if (*(ucpInBuff + Sections[SectionIndex].StartPosition + uiI) == BY_NAME_SYMBOL){    //REQUEST_DATA_BY_NAME_SYMBOL /*~*/
          cFieldName[0] = 0;
          bJ = false;
          for (j = 1; j < MAX_LABEL_NAME_LEGTH + 1; j++){
            cI = *(ucpInBuff + Sections[SectionIndex].StartPosition + uiI + j);
            if ( cI == BY_NAME_SYMBOL ){
              bJ = true;
              break;
            };
            cFieldName[j - 1] = cI;
            cFieldName[j] = 0;
          };
          if ( bJ ){  //if found
            if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, NEW_SECTION_START + SectionIndex, (WPARAM)(cFieldName), SECTION_DATA_REQUEST_BY_NAME);
            i = 0;
            LenRequestStr = RequestStr.Length();
            cpRequestStr = RequestStr.c_str();
            while ( i < LenRequestStr ){
              *(ucpOutBuff+uiOutP++) = cpRequestStr[i++];
              if ( uiOutP == FILE_BUFFER ){
                if ( FOutStream == NULL ){
                  if ( FWriteStreamPtr == NULL ){
                    WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
                  } else {
                    uiRW = (*(FWriteStreamPtr))((void*)ucpOutBuff, uiOutP, NULL);
                  };
                } else {
                  uiRW = FOutStream->Write(ucpOutBuff, FILE_BUFFER);
                };
                uiOutP = 0;
                if ((FILE_BUFFER) != uiRW){
                  if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
                  RaiseException(WRITE_EXCEPTION, 0, NULL, NULL);
                };
              };
            };
            uiI = uiI + j + 1;
          };
        };
        //
        *(ucpOutBuff+uiOutP) = *(ucpInBuff + Sections[SectionIndex].StartPosition + uiI);
        uiOutP++;
        if (uiOutP == FILE_BUFFER){
          if ( FOutStream == NULL ){
            if ( FWriteStreamPtr == NULL ){
              WriteFile(fhOutBlank, (LPCSTR)ucpOutBuff, uiOutP, (LPDWORD)&uiRW, NULL);
            } else {
              uiRW = (*(FWriteStreamPtr))((void*)ucpOutBuff, uiOutP, NULL);
            };
          } else {
            uiRW = FOutStream->Write(ucpOutBuff, FILE_BUFFER);
          };
          uiOutP = 0;
          if ((FILE_BUFFER) != uiRW){
            if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, WM_REP_WRITE_ERROR, 0, 0);
            RaiseException(WRITE_EXCEPTION, 0, NULL, NULL);
          };
        };
      };
      if ( FOnSmartReportMessage != NULL ) FOnSmartReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_END);
    };
  };
  if (FOnSmartReportMessage != NULL) FOnSmartReportMessage(this, NEW_SECTION_START + SectionIndex, 0, SECTION_COMPLIT);
};
//---------------------------------------------------------------------------

#pragma package(smart_init)
