//---------------------------------------------------------------------------

#ifndef SSmrtRepH
#define SSmrtRepH

#include <Classes.hpp>
#include "CommonType.h"

//
class TSmartRpt : public TThread
{
private:

  AnsiString            ucpIn;
	AnsiString            ucpOut;
  TStream *             FOutStream;
  TWriteStream          FWriteStreamPtr;
  TStream *             FInStream;
  TWriteStream          FReadStreamPtr;
  HANDLE                fhInBlank;
  HANDLE                fhOutBlank;
  unsigned int          uiSizeIn;
  unsigned int          uiOutP;
  AnsiString            RequestStr;
  HANDLE						    HInBuf;
  HANDLE						    HOutBuf;
  char *			          ucpInBuff;
  char *			          ucpOutBuff;
  char                  cFieldName[MAX_LABEL_NAME_LEGTH + 1];
  unsigned char         BY_NUM_SYMBOL;
  unsigned char         BY_NAME_SYMBOL;
  bool                  bCheck;
  AnsiString            SectionNames[13];
  bool                  fhOkIn;
  bool                  fhOkOut;

  AnsiString            FCurrentSection;
  int                   FCurrentSectionNum;
  int                   FLastDynSection;
  unsigned char         FPrepareDynSection;
  unsigned char         lWM_REP_SECTION_PREPARE;

  Section               Sections[MAX_SECTION_NUM];

	TOnReportMessage      FOnSmartReportMessage;

  void __fastcall PrepareSection(const AnsiString SectionName, const int SectionIndex);
  void __fastcall SeekTextWithBrackets(const AnsiString ucpW, FoundPar * fppP);
  void __fastcall OutSection(const bool bDefOut, const int SectionIndex);
  AnsiString __fastcall GetSectionName(int Index);

protected:

  void __fastcall Execute();

public:

  __fastcall TSmartRpt(void);
  __fastcall ~TSmartRpt(void);

  void __fastcall Build(void);
  void __fastcall OutSection(const AnsiString SectionName);
  void __fastcall OutSection(const int SectionNum);
  int __fastcall PrepareSection(const AnsiString SectionName);

  __property AnsiString InBlank = {read = ucpIn, write = ucpIn};
  __property TStream * InStream = {read = FInStream, write = FInStream};
  __property TWriteStream ReadStreamPtr = { read = FReadStreamPtr, write = FReadStreamPtr };

  __property AnsiString OutBlank = {read = ucpOut, write = ucpOut};
  __property TStream * OutStream = {read = FOutStream, write = FOutStream};
  __property TWriteStream WriteStreamPtr = { read = FWriteStreamPtr, write = FWriteStreamPtr };

  __property unsigned char SymbolByName = {read = BY_NAME_SYMBOL, write = BY_NAME_SYMBOL};
  __property unsigned char SymbolByNumber = {read = BY_NUM_SYMBOL, write = BY_NUM_SYMBOL};

  __property AnsiString DataRequest = {write = RequestStr};
  __property bool CheckRequest = {read = bCheck, write = bCheck};

  __property TOnReportMessage OnSmartReportMessage = { read =  FOnSmartReportMessage, write =  FOnSmartReportMessage};

  __property AnsiString SectionName[int Index] = {read = GetSectionName};
  __property AnsiString CurrentSection = {read = FCurrentSection};
  __property int CurrentSectionNum = {read = FCurrentSectionNum};

};

//---------------------------------------------------------------------------
#endif
