//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SmartWordStream.h"

//---------------------------------------------------------------------------
__fastcall TSmartWordStream::TSmartWordStream(TComponent* AOwner) : TComponent(AOwner){
	_SRpt = new TSmartRpt();
  CharByNum = REQUEST_DATA_BY_NUM_SYMBOL;
  CharByName = REQUEST_DATA_BY_NAME_SYMBOL;
  _SRpt->OnSmartReportMessage = &DispatchSmartMessages;
};

//---------------------------------------------------------------------------
__fastcall TSmartWordStream::~TSmartWordStream(void){
  _SRpt->~TSmartRpt();
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::SetInBlank(const AnsiString Value){
  FInBlank = Value;
	_SRpt->InBlank = Value;
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::SetOutBlank(const AnsiString Value){
  FOutBlank = Value;
  _SRpt->OutBlank = Value;
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::SetOutStream(TStream * Value){
	_SRpt->OutStream = Value;
};

//---------------------------------------------------------------------------
TStream * __fastcall TSmartWordStream::GetOutStream(void){
	return _SRpt->OutStream;
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::SetInStream(TStream * Value){
  _SRpt->InStream = Value;
};

//---------------------------------------------------------------------------
TStream * __fastcall TSmartWordStream::GetInStream(void){
  return _SRpt->InStream;
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::SectionHandler( Messages::TMessage &Msg,
                                TNotifyEvent  e0,
                                TOnCheck      e1,
                                TOnSectionDataRequestByNum  e2,
                                TOnSectionDataRequestByName e3,
                                TNotifyEvent  e4,
                                TNotifyEvent  e5,
                                bool  ch){
  cS = "";
  bCheck = ch;
  switch (Msg.LParam){
    case SECTION_DATA_REQUEST_BY_NUM:
      if ( e2 != NULL ) e2(this, Msg.WParam, cS);
        else if (OnSectionDataRequestByNum) OnSectionDataRequestByNum(this, Msg.WParam, cS);
      _SRpt->DataRequest = cS;
      break;
    case SECTION_DATA_REQUEST_BY_NAME:
      cFieldName = AnsiString((char*)Msg.WParam);
      if ( e3 != NULL) e3(this, cFieldName, cS);
        else if (OnSectionDataRequestByName != NULL) OnSectionDataRequestByName(this, cFieldName, cS);
      _SRpt->DataRequest = cS;
      break;
    case SECTION_CHECK:
      if ( e1 != NULL) e1(this, bCheck);
        else if (OnSectionCheck != NULL) OnSectionCheck(this, bCheck);
      _SRpt->CheckRequest = bCheck;   //print section with this record or not
      break;
    case SECTION_BEGIN: if ( e0 != NULL) e0(this); else if (OnSectionBegin != NULL) OnSectionBegin(this); break;
    case SECTION_END: if (e4 != NULL) e4(this); else if (OnSectionEnd != NULL) OnSectionEnd(this); break;
    case SECTION_COMPLIT: if (e5 != NULL) e5(this); else if (OnSectionComplit != NULL) OnSectionComplit(this); break;
  };
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::MsgStartReport(Messages::TMessage &Msg){
  _SRpt->SymbolByNumber = CharByNum;
  _SRpt->SymbolByName = CharByName;
  if (OnStartReport != NULL) OnStartReport(this);
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::MsgEndReport(Messages::TMessage &Msg){
  if (OnEndReport != NULL) OnEndReport(this);
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::MsgReportMove(Messages::TMessage &Msg){
  bCheck = true;
  if (Msg.LParam == MOVE_TOP){
    if (OnMoveTop != NULL) OnMoveTop(this, bCheck);
  } else {
    if (Msg.LParam == MOVE_NEXT) if (OnMoveNext != NULL) OnMoveNext(this, bCheck);
  };
  _SRpt->CheckRequest = bCheck;
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::MsgReportError(Messages::TMessage &Msg){
  switch (Msg.Msg){
    case WM_REP_THREAD_ERROR:    cS = "Thread Error"; break;
    case WM_REP_OPEN_ERROR:      cS = "Open Error"; break;
    case WM_REP_CREATE_ERROR:    cS = "Create Error"; break;
    case WM_REP_MEM_ERROR:       cS = "Memory Error"; break;
    case WM_REP_READ_ERROR:      cS = "Read Error"; break;
    case WM_REP_SECTION_ERROR:   cS = "Section Error"; break;
    case WM_REP_WRITE_ERROR:     cS = "Write Error"; break;
  };
  if (OnReportError != NULL) OnReportError(this, Msg, cS);
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::DispatchSmartMessages(TObject * Sender, const int iMessage, const int iW, const int iL){
  TMessage Msg;
  Msg.Msg = iMessage;
  Msg.WParam = iW;
  Msg.LParam = iL;
  switch (iMessage){
    case WM_REP_START_REPORT:           MsgStartReport(Msg); break;
    case WM_REP_END_REPORT:             MsgEndReport(Msg); break;

    case WM_REP_MOVE:                   MsgReportMove(Msg); break;
    case WM_REP_THREAD_ERROR:           MsgReportError(Msg); break;
    case WM_REP_OPEN_ERROR:             MsgReportError(Msg); break;
    case WM_REP_CREATE_ERROR:           MsgReportError(Msg); break;
    case WM_REP_MEM_ERROR:              MsgReportError(Msg); break;
    case WM_REP_READ_ERROR:             MsgReportError(Msg); break;
    case WM_REP_SECTION_ERROR:          MsgReportError(Msg); break;
    case WM_REP_WRITE_ERROR:            MsgReportError(Msg); break;
    case WM_REP_SECTION_PREPARE:
      if (OnSectionPrepare != NULL) OnSectionPrepare(this); break;
  default:
    if (iMessage >= WM_REP_RTF_HEADER)
      SectionHandler(Msg, OnSectionBegin,
      OnSectionCheck, OnSectionDataRequestByNum,
      OnSectionDataRequestByName, OnSectionEnd, OnSectionComplit, _SRpt->CheckRequest);
    break;
  };
};

//---------------------------------------------------------------------------
AnsiString __fastcall TSmartWordStream::GetCurrentSection(void){
  return _SRpt->CurrentSection;
};

//---------------------------------------------------------------------------
int __fastcall TSmartWordStream::GetCurrentSectionNum(void){
  return _SRpt->CurrentSectionNum;
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::Execute(void){
  _SRpt->Build();
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::Start(void){
	_SRpt->Resume();
};

//---------------------------------------------------------------------------
int __fastcall TSmartWordStream::PrepareSection(const AnsiString SectionName){
  return _SRpt->PrepareSection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::OutSection(const AnsiString SectionName){
  _SRpt->OutSection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TSmartWordStream::OutSectionByNum(int SectionNum){
  _SRpt->OutSection(SectionNum);
};

//---------------------------------------------------------------------------

#pragma package(smart_init)
