//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SylkReport.h"
#pragma link "SSmrtRep"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSylkReport *)
{
  new TSylkReport(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSylkReport::TSylkReport(TComponent* Owner)
  : TReportAbstract(Owner)
{
    FSylkStrim = new TSylkStream(this);
}

//---------------------------------------------------------------------------
__fastcall TSylkReport::~TSylkReport(void){
  FSylkStrim->~TSylkStream();
};


//---------------------------------------------------------------------------
AnsiString __fastcall TSylkReport::GetInputBlank(void){
  return FSylkStrim->InputBlank;
};

//---------------------------------------------------------------------------
AnsiString __fastcall TSylkReport::GetOutputBlank(void){
  return FSylkStrim->OutputBlank;
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::SetInputBlank(const AnsiString Value){
  FSylkStrim->InputBlank = Value;
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::SetOutputBlank(const AnsiString Value){
  FSylkStrim->OutputBlank = Value;
};

//---------------------------------------------------------------------------
char __fastcall TSylkReport::GetCharByName(void){
  return FSylkStrim->CharByName;
};

//---------------------------------------------------------------------------
char __fastcall TSylkReport::GetCharByNum(void){
  return FSylkStrim->CharByNum;
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::SetCharByName(const char Value){
  FSylkStrim->CharByName = Value;
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::SetCharByNum(const char Value){
  FSylkStrim->CharByNum = Value;
};


//---------------------------------------------------------------------------
void __fastcall TSylkReport::OnErrorH(TObject* Sender, TMessage &Msg, AnsiString &sStr){
  if (OnReportError != NULL) OnReportError(this, Msg.Msg, Msg.LParam, sStr);
};


//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionBegin(TObject* Sender){
  if (OnSectionBegin != NULL) OnSectionBegin(this, FSylkStrim->CurrentSection, FSylkStrim->CurrentSectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionCheck(TObject* Sender, bool &bCheck){
  if (OnSectionCheck != NULL) OnSectionCheck(this, FSylkStrim->CurrentSection, FSylkStrim->CurrentSectionNum, bCheck);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionDataRequestByCell(TObject* Sender, DataRq &RqData){
  FRqData = RqData;
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionDataRequestByVal(TObject* Sender, int &iP, AnsiString &sStr){
  bool bCheck;
  Variant SVar;
  SVar = iP;
  bCheck = false;
  if (OnDataRequest != NULL) OnDataRequest( this,
                                            FSylkStrim->CurrentSection,
                                            FSylkStrim->CurrentSectionNum,
                                            SVar,
                                            bCheck,
                                            FRqData.CurrCell.iRow,
                                            FRqData.CurrCell.iCol,
                                            FRqData.BlankCell.iRow,
                                            FRqData.BlankCell.iCol);
  if (! bCheck){ sStr = ""; } else {
    sStr = VarToStr(SVar);
    if ( (VarType(SVar) == varOleStr) || (VarType(SVar) == varString) ){
      sStr = "\x22" + sStr + "\x22";
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionRqByNum(TObject* Sender, int &iP, AnsiString &sStr){
  if (OnRequestByNum != NULL) OnRequestByNum(this, FSylkStrim->CurrentSection, iP, sStr);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionRqByName(TObject* Sender, AnsiString &sFieldName, AnsiString &sStr){
  if (OnRequestByName != NULL) OnRequestByName(this, FSylkStrim->CurrentSection, sFieldName, sStr);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionEnd(TObject* Sender){
  if (OnSectionEnd != NULL) OnSectionEnd(this, FSylkStrim->CurrentSection, FSylkStrim->CurrentSectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::lOnSectionComplit(TObject* Sender){
  if (OnSectionComplit != NULL) OnSectionComplit(this, FSylkStrim->CurrentSection, FSylkStrim->CurrentSectionNum);
};


//---------------------------------------------------------------------------
void __fastcall TSylkReport::EventsRedirect(void){

  FSylkStrim->OnStartReport = OnStartReport;
  FSylkStrim->OnEndReport = OnEndReport;

  FSylkStrim->OnMoveTop = OnMoveTop;
  FSylkStrim->OnMoveNext = OnMoveNext;

  FSylkStrim->OnReportError = OnErrorH;

  FSylkStrim->OnSectionBegin =             lOnSectionBegin;
  FSylkStrim->OnSectionCheck =             lOnSectionCheck;
  FSylkStrim->OnSectionDataRequestByCell = lOnSectionDataRequestByCell;
  FSylkStrim->OnSectionDataRequestByVal =  lOnSectionDataRequestByVal;
  FSylkStrim->OnSectionDataRequestByNum =  lOnSectionRqByNum;
  FSylkStrim->OnSectionDataRequestByName = lOnSectionRqByName;
  FSylkStrim->OnSectionEnd =               lOnSectionEnd;
  FSylkStrim->OnSectionComplit =           lOnSectionComplit;

  FSylkStrim->OnSectionPrepare = OnSectionPrepare;

};


//---------------------------------------------------------------------------
AnsiString __fastcall TSylkReport::GetCurrentSection(void){
  return FSylkStrim->CurrentSection;
};

//---------------------------------------------------------------------------
int __fastcall TSylkReport::GetCurrentSectionNum(void){
  return FSylkStrim->CurrentSectionNum;
};

//---------------------------------------------------------------------------
TTtypeDiraction __fastcall TSylkReport::GetTypeDiraction(void){
  return FSylkStrim->TypeDiraction;
};


//---------------------------------------------------------------------------
void __fastcall TSylkReport::ReportResume(void){
  EventsRedirect();
  FSylkStrim->ReportResume();
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::ReportExecute(void){
  EventsRedirect();
  FSylkStrim->ReportExecute();
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::ReportHorizontalyResume(void){
  EventsRedirect();
  FSylkStrim->ReportHorizontalyResume();
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::ReportHorizontalyExecute(void){
  EventsRedirect();
  FSylkStrim->ReportHorizontalyExecute();
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::BiDirectionResume(void){
  EventsRedirect();
  FSylkStrim->BiDirectionResume();
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::BiDirectionExecute(void){
  EventsRedirect();
  FSylkStrim->BiDirectionExecute();
};

//---------------------------------------------------------------------------
int __fastcall TSylkReport::PrepareSection(const AnsiString SectionName){
  return FSylkStrim->PrepareSection(SectionName);
};

//---------------------------------------------------------------------------
int __fastcall TSylkReport::PrepareHorizontalySection(const AnsiString SectionName){
  return FSylkStrim->PrepareHorizontalySection(SectionName);
};


//---------------------------------------------------------------------------
void __fastcall TSylkReport::OutSection(AnsiString SectionName){
  FSylkStrim->OutSection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::OutHorizontalySection(AnsiString SectionName){
  FSylkStrim->OutHorizontalySection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::OutSection(int SectionNum){
  FSylkStrim->OutSection(SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TSylkReport::OutHorizontalySection(int SectionNum){
  FSylkStrim->OutHorizontalySection(SectionNum);
};



//---------------------------------------------------------------------------
