//---------------------------------------------------------------------------

#ifndef SylkReportH
#define SylkReportH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "SSmrtRep.h"
#include "SylkStream.h"
#include "CommonType.h"

//---------------------------------------------------------------------------
class PACKAGE TSylkReport : public TReportAbstract
{
private:

  TSylkStream*            FSylkStrim;
  DataRq                  FRqData;

  AnsiString __fastcall GetInputBlank(void);
  AnsiString __fastcall GetOutputBlank(void);
  void __fastcall SetInputBlank(const AnsiString Value);
  void __fastcall SetOutputBlank(const AnsiString Value);
  char __fastcall GetCharByName(void);
  char __fastcall GetCharByNum(void);
  void __fastcall SetCharByName(const char Value);
  void __fastcall SetCharByNum(const char Value);

  void __fastcall OnErrorH(TObject* Sender, TMessage &Msg, AnsiString &sStr);

  void __fastcall lOnSectionBegin(TObject* Sender);
  void __fastcall lOnSectionCheck(TObject* Sender, bool &bCheck);
  void __fastcall lOnSectionDataRequestByCell(TObject* Sender, DataRq &RqData);
  void __fastcall lOnSectionDataRequestByVal(TObject* Sender, int &iP, AnsiString &sStr);
  void __fastcall lOnSectionRqByNum(TObject* Sender, int &iP, AnsiString &sStr);
  void __fastcall lOnSectionRqByName(TObject* Sender, AnsiString &sFieldName, AnsiString &sStr);
  void __fastcall lOnSectionEnd(TObject* Sender);
  void __fastcall lOnSectionComplit(TObject* Sender);

  void __fastcall EventsRedirect(void);

protected:

  AnsiString __fastcall GetCurrentSection(void);
  int __fastcall GetCurrentSectionNum(void);
  TTtypeDiraction __fastcall GetTypeDiraction(void);

  TWriteStream __fastcall GetWriteStream(void){
    return FSylkStrim->WriteStreamPtr;
  };
  void __fastcall SetWriteStream(TWriteStream Value){
    FSylkStrim->WriteStreamPtr = Value;
  };

  TWriteStream __fastcall GetReadStream(void){
    return FSylkStrim->ReadStreamPtr;
  };
  void __fastcall SetReadStream(TWriteStream Value){
    FSylkStrim->ReadStreamPtr = Value;
  };

  TStream* __fastcall GetInputStream(void){
    return FSylkStrim->InStream;
  };
  void __fastcall SetInputStream(TStream* Value){
    FSylkStrim->InStream = Value;
  };

  TStream* __fastcall GetOutputStream(void){
    return FSylkStrim->OutStream;
  };
  void __fastcall SetOutputStream(TStream* Value){
    FSylkStrim->OutStream = Value;
  };

public:

  __fastcall TSylkReport(TComponent* Owner);
  __fastcall ~TSylkReport(void);

  void __fastcall ReportResume(void);
  void __fastcall ReportExecute(void);
  void __fastcall ReportHorizontalyResume(void);
  void __fastcall ReportHorizontalyExecute(void);
  void __fastcall BiDirectionResume(void);
  void __fastcall BiDirectionExecute(void);
  int __fastcall PrepareSection(const AnsiString SectionName);
  int __fastcall PrepareHorizontalySection(const AnsiString SectionName);

  void __fastcall OutSection(AnsiString SectionName);
  void __fastcall OutHorizontalySection(AnsiString SectionName);
  void __fastcall OutSection(int SectionNum);
  void __fastcall OutHorizontalySection(int SectionNum);

  __property TSylkStream* SylkStrim = { read = FSylkStrim };


__published:

  __property AnsiString InputBlank = { read = GetInputBlank, write = SetInputBlank };
  __property AnsiString OutputBlank = { read = GetOutputBlank, write = SetOutputBlank };
  __property char CharByNum = { read = GetCharByNum, write = SetCharByNum };
  __property char CharByName = { read = GetCharByName, write = SetCharByName };

  __property OnStartReport;
  __property OnEndReport;
  __property OnReportError;
  __property OnMoveTop;
  __property OnMoveNext;
  __property OnSectionBegin;
  __property OnSectionEnd;
  __property OnSectionComplit;
  __property OnSectionCheck;
  __property OnDataRequest;
  __property OnRequestByName;
  __property OnRequestByNum;
  __property OnSectionPrepare;

};
//---------------------------------------------------------------------------
#endif
