//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "WordReport.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TWordReport *)
{
  new TWordReport(NULL);
}
//---------------------------------------------------------------------------
__fastcall TWordReport::TWordReport(TComponent* Owner)
  : TReportAbstract(Owner)
{
    FWordStrim = new TSmartWordStream(this);
}

//---------------------------------------------------------------------------
__fastcall TWordReport::~TWordReport(void){
  FWordStrim->Free();
};

//---------------------------------------------------------------------------
AnsiString __fastcall TWordReport::GetInputBlank(void){
  return FWordStrim->InBlank;
};

//---------------------------------------------------------------------------
AnsiString __fastcall TWordReport::GetOutputBlank(void){
  return FWordStrim->OutBlank;
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::SetInputBlank(const AnsiString Value){
  FWordStrim->InBlank = Value;
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::SetOutputBlank(const AnsiString Value){
  FWordStrim->OutBlank = Value;
};

//---------------------------------------------------------------------------
char __fastcall TWordReport::GetCharByName(void){
  return FWordStrim->CharByName;
};

//---------------------------------------------------------------------------
char __fastcall TWordReport::GetCharByNum(void){
  return FWordStrim->CharByNum;
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::SetCharByName(const char Value){
  FWordStrim->CharByName = Value;
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::SetCharByNum(const char Value){
  FWordStrim->CharByNum = Value;
};


//---------------------------------------------------------------------------
void __fastcall TWordReport::OnErrorH(TObject * Sender, Messages::TMessage &Msg, AnsiString &sStr){
  if (OnReportError != NULL) OnReportError(this, Msg.Msg, Msg.LParam, sStr);
};


//---------------------------------------------------------------------------
void __fastcall TWordReport::lOnSectionBegin(TObject * Sender){
  if (OnSectionBegin != NULL) OnSectionBegin(this, FWordStrim->CurrentSection, FWordStrim->CurrentSectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::lOnSectionCheck(TObject * Sender, bool &bCheck){
  if (OnSectionCheck != NULL) OnSectionCheck(this, FWordStrim->CurrentSection, FWordStrim->CurrentSectionNum, bCheck);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::lOnSectionRqByNum(TObject * Sender, int &iP, AnsiString &sStr){
  if (OnRequestByNum != NULL) OnRequestByNum(this, FWordStrim->CurrentSection, iP, sStr);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::lOnSectionRqByName(TObject * Sender, AnsiString &sFieldName, AnsiString &sStr){
  if (OnRequestByName != NULL) OnRequestByName(this, FWordStrim->CurrentSection, sFieldName, sStr);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::lOnSectionEnd(TObject * Sender){
  if (OnSectionEnd != NULL) OnSectionEnd(this, FWordStrim->CurrentSection, FWordStrim->CurrentSectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::lOnSectionComplit(TObject * Sender){
  if (OnSectionComplit != NULL) OnSectionComplit(this, FWordStrim->CurrentSection, FWordStrim->CurrentSectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::EventsRedirect(void){

  FWordStrim->OnStartReport = OnStartReport;
  FWordStrim->OnEndReport = OnEndReport;

  FWordStrim->OnMoveTop = OnMoveTop;
  FWordStrim->OnMoveNext = OnMoveNext;

  FWordStrim->OnReportError = OnErrorH;

  FWordStrim->OnSectionBegin =             lOnSectionBegin;
  FWordStrim->OnSectionCheck =             lOnSectionCheck;
  FWordStrim->OnSectionDataRequestByNum =  lOnSectionRqByNum;
  FWordStrim->OnSectionDataRequestByName = lOnSectionRqByName;
  FWordStrim->OnSectionEnd =               lOnSectionEnd;
  FWordStrim->OnSectionComplit =           lOnSectionComplit;

  FWordStrim->OnSectionPrepare = OnSectionPrepare;

};

//---------------------------------------------------------------------------
AnsiString __fastcall TWordReport::GetCurrentSection(void){
  return FWordStrim->CurrentSection;
};

//---------------------------------------------------------------------------
int __fastcall TWordReport::GetCurrentSectionNum(void){
  return FWordStrim->CurrentSectionNum;
};

//---------------------------------------------------------------------------
TTtypeDiraction __fastcall TWordReport::GetTypeDiraction(void){
  return tdVerticaly;
};


//---------------------------------------------------------------------------
void __fastcall TWordReport::ReportResume(void){
  EventsRedirect();
  FWordStrim->Start();
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::ReportExecute(void){
  EventsRedirect();
  FWordStrim->Execute();
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::ReportHorizontalyResume(void){
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::ReportHorizontalyExecute(void){
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::BiDirectionResume(void){
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::BiDirectionExecute(void){
};

//---------------------------------------------------------------------------
int __fastcall TWordReport::PrepareSection(const AnsiString SectionName){
  return FWordStrim->PrepareSection(SectionName);
};

//---------------------------------------------------------------------------
int __fastcall TWordReport::PrepareHorizontalySection(const AnsiString SectionName){
  return FWordStrim->PrepareSection(SectionName);
};


//---------------------------------------------------------------------------
void __fastcall TWordReport::OutSection(const AnsiString SectionName){
  FWordStrim->OutSection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::OutHorizontalySection(const AnsiString SectionName){
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::OutSection(int SectionNum){
  FWordStrim->OutSectionByNum(SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TWordReport::OutHorizontalySection(int SectionNum){
};


//---------------------------------------------------------------------------

