//---------------------------------------------------------------------------

#ifndef WordReportH
#define WordReportH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

#include "CommonType.h"
#include "SmartWordStream.h"

//---------------------------------------------------------------------------
class PACKAGE TWordReport : public TReportAbstract
{
private:

  TSmartWordStream *  FWordStrim;

  AnsiString __fastcall GetInputBlank(void);
  AnsiString __fastcall GetOutputBlank(void);
  void __fastcall SetInputBlank(const AnsiString Value);
  void __fastcall SetOutputBlank(const AnsiString Value);
  char __fastcall GetCharByName(void);
  char __fastcall GetCharByNum(void);
  void __fastcall SetCharByName(const char Value);
  void __fastcall SetCharByNum(const char Value);

  void __fastcall OnErrorH(TObject * Sender, Messages::TMessage &Msg, AnsiString &sStr);

  void __fastcall lOnSectionBegin(TObject * Sender);
  void __fastcall lOnSectionCheck(TObject * Sender, bool &bCheck);
  void __fastcall lOnSectionRqByNum(TObject * Sender, int &iP, AnsiString &sStr);
  void __fastcall lOnSectionRqByName(TObject * Sender, AnsiString &sFieldName, AnsiString &sStr);
  void __fastcall lOnSectionEnd(TObject * Sender);
  void __fastcall lOnSectionComplit(TObject * Sender);

  void __fastcall EventsRedirect(void);

protected:

  AnsiString __fastcall GetCurrentSection(void);
  int __fastcall GetCurrentSectionNum(void);
  TTtypeDiraction __fastcall GetTypeDiraction(void);

  TWriteStream __fastcall GetWriteStream(void){
    return FWordStrim->WriteStreamPtr;
  };
  void __fastcall SetWriteStream(TWriteStream Value){
    FWordStrim->WriteStreamPtr = Value;
  };

  TWriteStream __fastcall GetReadStream(void){
    return FWordStrim->ReadStreamPtr;
  };
  void __fastcall SetReadStream(TWriteStream Value){
    FWordStrim->ReadStreamPtr = Value;
  };

  TStream* __fastcall GetInputStream(void){
    return FWordStrim->InStream;
  };
  void __fastcall SetInputStream(TStream* Value){
    FWordStrim->InStream = Value;
  };

  TStream* __fastcall GetOutputStream(void){
    return FWordStrim->OutStream;
  };
  void __fastcall SetOutputStream(TStream* Value){
    FWordStrim->OutStream = Value;
  };

public:

  __fastcall TWordReport(TComponent* Owner);
  __fastcall ~TWordReport(void);

  void __fastcall ReportResume(void);
  void __fastcall ReportExecute(void);
  void __fastcall ReportHorizontalyResume(void);
  void __fastcall ReportHorizontalyExecute(void);
  void __fastcall BiDirectionResume(void);
  void __fastcall BiDirectionExecute(void);
  int __fastcall PrepareSection(const AnsiString SectionName);
  int __fastcall PrepareHorizontalySection(const AnsiString SectionName);

  void __fastcall OutSection(const AnsiString SectionName);
  void __fastcall OutHorizontalySection(const AnsiString SectionName);
  void __fastcall OutSection(int SectionNum);
  void __fastcall OutHorizontalySection(int SectionNum);

  __property TSmartWordStream* WordStrim = { read = FWordStrim };

__published:

    __property AnsiString InputBlank = { read = GetInputBlank, write = SetInputBlank };
    __property AnsiString OutputBlank = { read = GetOutputBlank, write = SetOutputBlank };
    __property char CharByNum = { read = GetCharByNum, write = SetCharByNum, default = REQUEST_DATA_BY_NUM_SYMBOL };
    __property char CharByName = { read = GetCharByName, write = SetCharByName, default = REQUEST_DATA_BY_NAME_SYMBOL };

    __property OnStartReport;
    __property OnEndReport;
    __property OnReportError;
    __property OnMoveTop;
    __property OnMoveNext;
    __property OnSectionBegin;
    __property OnSectionEnd;
    __property OnSectionComplit;
    __property OnSectionCheck;
    __property OnDataRequest;
    __property OnRequestByName;
    __property OnRequestByNum;
    __property OnSectionPrepare;

};
//---------------------------------------------------------------------------
#endif
