//---------------------------------------------------------------------------

#include <vcl.h>
#include <Math.h>
#pragma hdrstop

#include "XLS4Report.h"
#include "ExcelReport.h"
#pragma link "SSmrtRep"
#pragma package(smart_init)

#pragma pack(push, 1)

static void __GetTmpFileName(char * cpTempFile /*Must be MAX_PATH + 1 length*/);

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TXLS4Report *)
{
  new TXLS4Report(NULL);
}
//---------------------------------------------------------------------------
__fastcall TXLS4Report::TXLS4Report(TComponent* Owner)
  : TReportAbstract(Owner)
{
  FCharByNum = 35;
  FCharByName = 126;
  FLastDynSection = 13;
  FLastDynSectionH = 13;
  lWM_REP_SECTION_PREPARE = false;
  FInputStream = NULL;
  FOutputStream = NULL;
  BiffBody = NULL;
  CoGetMalloc(1, &IAlloc);
}

__fastcall TXLS4Report::~TXLS4Report(void){
  CloseSectionsH();
  CloseSectionsV();
  IAlloc->Release();
};

//---------------------------------------------------------------------------

AnsiString __fastcall TXLS4Report::GetInputBlank(void){
  return FInputBlank;
};

//---------------------------------------------------------------------------
AnsiString __fastcall TXLS4Report::GetOutputBlank(void){
  return FOutputBlank;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetInputBlank(const AnsiString Value){
  FInputBlank = Value;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetOutputBlank(const AnsiString Value){
  FOutputBlank = Value;
};

//---------------------------------------------------------------------------
char __fastcall TXLS4Report::GetCharByName(void){
  return FCharByName;
};

//---------------------------------------------------------------------------
char __fastcall TXLS4Report::GetCharByNum(void){
  return FCharByNum;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetCharByName(const char Value){
  FCharByName = Value;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetCharByNum(const char Value){
  FCharByNum = Value;
};

//---------------------------------------------------------------------------
AnsiString __fastcall TXLS4Report::GetCurrentSection(void){
  return FCurrentSection;
};

//---------------------------------------------------------------------------
int __fastcall TXLS4Report::GetCurrentSectionNum(void){
  return FCurrentSectionNum;
};

//---------------------------------------------------------------------------
TTtypeDiraction __fastcall TXLS4Report::GetTypeDiraction(void){
  return FTypeDiraction;
};

//---------------------------------------------------------------------------
TWriteStream __fastcall TXLS4Report::GetWriteStream(void){
  return NULL;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetWriteStream(TWriteStream Value){
};

//---------------------------------------------------------------------------
TWriteStream __fastcall TXLS4Report::GetReadStream(void){
  return NULL;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetReadStream(TWriteStream Value){
};

//---------------------------------------------------------------------------
TStream* __fastcall TXLS4Report::GetInputStream(void){
  return FInputStream;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetInputStream(TStream* Value){
  FInputStream = Value;
};

//---------------------------------------------------------------------------
TStream* __fastcall TXLS4Report::GetOutputStream(void){
  return FOutputStream;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::SetOutputStream(TStream* Value){
  FOutputStream = Value;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::ReportResume(void){
  TRThread* FThread = new TRThread(true);
  FThread->OnExecute = StartReportV;
  FThread->FreeOnTerminate = true;
  FThread->Resume();
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::ReportExecute(void){
  StartReportV();
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::ReportHorizontalyResume(void){
  TRThread* FThread = new TRThread(true);
  FThread->OnExecute = StartReportH;
  FThread->FreeOnTerminate = true;
  FThread->Resume();
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::ReportHorizontalyExecute(void){
  StartReportH();
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::BiDirectionResume(void){
  TRThread* FThread = new TRThread(true);
  FThread->OnExecute = StartBiDirectionReport;
  FThread->FreeOnTerminate = true;
  FThread->Resume();
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::BiDirectionExecute(void){
  StartBiDirectionReport();
};

//---------------------------------------------------------------------------
int __fastcall TXLS4Report::PrepareSection(const AnsiString SectionName){
  int Result;
  if (FLastDynSection > MAX_SECTION_NUM)
    if (OnReportError != NULL) OnReportError(this, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, "LIMIT EXCEEDED");
  if (! lWM_REP_SECTION_PREPARE )
    if (OnReportError != NULL) OnReportError(this, WM_REP_ALLAGIAL_CALL, 0, "ALLAGIAL CALL");
  Result = FLastDynSection++;
  PrepareSectionV(SectionName, Result);
  return Result;
};

//---------------------------------------------------------------------------
int __fastcall TXLS4Report::PrepareHorizontalySection(const AnsiString SectionName){
  int Result;
  if (FLastDynSectionH > MAX_SECTION_NUM)
    if (OnReportError != NULL) OnReportError(this, WM_REP_MAX_DYN_SECTION_EXCEEDED, 0, "LIMIT EXCEEDED");
  if (! lWM_REP_SECTION_PREPARE )
    if (OnReportError != NULL) OnReportError(this, WM_REP_ALLAGIAL_CALL, 0, "ALLAGIAL CALL");
  Result = FLastDynSectionH++;
  PrepareSectionH(SectionName, Result);
  return Result;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutSection(AnsiString SectionName){
  int i;
  if (SectionName == "REPORTHEADER"){
    OutSectionV("REPORTHEADER", true, 1);
    goto lEnd;
  };
  if (SectionName == "GROUPHEADER"){
    OutSectionV("GROUPHEADER", true, 2);
    goto lEnd;
  };
  if (SectionName == "SUBGROUPHEADER"){
    OutSectionV("SUBGROUPHEADER", true, 3);
    goto lEnd;
  };
  if (SectionName == "SUBSUBGROUPHEADER"){
    OutSectionV("SUBSUBGROUPHEADER", true, 4);
    goto lEnd;
  };
  if (SectionName == "SUPERSUBGROUPHEADER"){
    OutSectionV("SUPERSUBGROUPHEADER", true, 5);
    goto lEnd;
  };
  if (SectionName == "BODY"){
    OutSectionV("BODY", true, 6);
    goto lEnd;
  };
  if (SectionName == "SUPERSUBGROUPFOOTER"){
    OutSectionV("SUPERSUBGROUPFOOTER", true, 7);
    goto lEnd;
  };
  if (SectionName == "SUBSUBGROUPFOOTER"){
    OutSectionV("SUBSUBGROUPFOOTER", true, 8);
    goto lEnd;
  };
  if (SectionName == "SUBGROUPFOOTER"){
    OutSectionV("SUBGROUPFOOTER", true, 9);
    goto lEnd;
  };
  if (SectionName == "GROUPFOOTER"){
    OutSectionV("GROUPFOOTER", true, 10);
    goto lEnd;
  };
  if (SectionName == "REPORTFOOTER"){
    OutSectionV("REPORTFOOTER", true, 11);
    goto lEnd;
  };
  // if Section is a Dynamic.
  for (i=13;i<MAX_SECTION_NUM;i++)
    if ( SectionName == FSectionsV[i].SectionName ){
      OutSectionV(SectionName, true, i);
      break;
    };
lEnd:
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutHorizontalySection(AnsiString SectionName){
  int i;
  if (SectionName == "H_REPORTHEADER"){
    OutSectionH("H_REPORTHEADER", true, 1);
    goto lEnd;
  };
  if (SectionName == "H_GROUPHEADER"){
    OutSectionH("H_GROUPHEADER", true, 2);
    goto lEnd;
  };
  if (SectionName == "H_SUBGROUPHEADER"){
    OutSectionH("H_SUBGROUPHEADER", true, 3);
    goto lEnd;
  };
  if (SectionName == "H_SUBSUBGROUPHEADER"){
    OutSectionH("H_SUBSUBGROUPHEADER", true, 4);
    goto lEnd;
  };
  if (SectionName == "H_SUPERSUBGROUPHEADER"){
    OutSectionH("H_SUPERSUBGROUPHEADER", true, 5);
    goto lEnd;
  };
  if (SectionName == "H_BODY"){
    OutSectionH("H_BODY", true, 6);
    goto lEnd;
  };
  if (SectionName == "H_SUPERSUBGROUPFOOTER"){
    OutSectionH("H_SUPERSUBGROUPFOOTER", true, 7);
    goto lEnd;
  };
  if (SectionName == "H_SUBSUBGROUPFOOTER"){
    OutSectionH("H_SUBSUBGROUPFOOTER", true, 8);
    goto lEnd;
  };
  if (SectionName == "H_SUBGROUPFOOTER"){
    OutSectionH("H_SUBGROUPFOOTER", true, 9);
    goto lEnd;
  };
  if (SectionName == "H_GROUPFOOTER"){
    OutSectionH("H_GROUPFOOTER", true, 10);
    goto lEnd;
  };
  if (SectionName == "H_REPORTFOOTER"){
    OutSectionH("H_REPORTFOOTER", true, 11);
    goto lEnd;
  };
  // if Section is a Dynamic.
  for (i=13;i<MAX_SECTION_NUM;i++)
    if ( SectionName == FSectionsH[i].SectionName ){
      OutSectionH(SectionName, true, i);
      break;
    };
lEnd:
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutSection(int SectionNum){
  OutSectionV(FSectionsV[SectionNum].SectionName, true, SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutHorizontalySection(int SectionNum){
  OutSectionH(FSectionsH[SectionNum].SectionName, true, SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::CloseBody(void){
  int j, k;
  pTBiffRec pp;
  k = BiffBody->Count - 1;
  for (j=0;j<=k;j++){
    pp = pTBiffRec(BiffBody->Items[j]);
    if (pp->head.Length > 0) IAlloc->Free(pp->data);
    IAlloc->Free(pp);
  };
  BiffBody->Free();
  BiffBody = NULL;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::PrepareFileHeaderV(void){
  WORD*   qq;
  TBiffRecHeader r_h;
  pTBiffRec pp;
	FSectionsV[0].SectionName = "FILEHEADER";
	FSectionsV[0].SectionNum = 0;
	FSectionsV[0].SectionUsed = true;
  FSectionsV[0].Contents = new TList();
  while ( true ){
    FInputStream->Read((void*)&r_h, 4);
    pp = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
    memset(pp, 0, sizeof(TBiffRec));
    pp->head.Opcode = r_h.Opcode;
    pp->head.Length = r_h.Length;
    pp->data = NULL;
    pp->r = 0;
    pp->c = 0;
    pp->d = Unassigned;
    pp->d = Null;
    if ( r_h.Length > 0 ){
      pp->data = IAlloc->Alloc(r_h.Length);
      FInputStream->Read(pp->data, r_h.Length);
    };
    if ( r_h.Opcode == 0x200 ){ //Dimentions
      qq = (WORD*)(pp->data);
      *qq = 0;
      *(qq + 1) = 0xFFFF;
      *(qq + 2) = 0;
      *(qq + 3) = 0xFF;
    };
    FSectionsV[0].Contents->Add(pp);
    if (r_h.Opcode == 0x200 ) break; //Dimentions
  };
  while ( true ){
    FInputStream->Read((void*)&r_h, 4);
    pp = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
    memset(pp, 0, sizeof(TBiffRec));
    pp->head.Opcode = r_h.Opcode;
    pp->head.Length = r_h.Length;
    pp->data = NULL;
    pp->r = 0;
    pp->c = 0;
    pp->d = Unassigned;
    pp->d = Null;
    if ( r_h.Length > 0 ){
      pp->data = IAlloc->Alloc(r_h.Length);
      FInputStream->Read(pp->data, r_h.Length);
    };
    BiffBody->Add(pp);
    if ( r_h.Opcode == 0x0A ) break; //EOF
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::PrepareFileFooterV(void){
  int i;
  TBiffRec pp;
  pTBiffRec qq;
	FSectionsV[12].SectionName = "FILEFOOTER";
	FSectionsV[12].SectionNum = 12;
	FSectionsV[12].SectionUsed = true;
  FSectionsV[12].Contents = new TList();
  for (i=LHandle + 1;i<BiffBody->Count;i++){
    pp = *((pTBiffRec)(BiffBody->Items[i]));
    qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
    memset(qq, 0, sizeof(TBiffRec));
    qq->head.Opcode = pp.head.Opcode;
    qq->head.Length = pp.head.Length;
    qq->data = NULL;
    qq->r = 0;
    qq->c = 0;
    qq->d = Unassigned;
    qq->d = Null;
    if ( pp.head.Length > 0 ){
      qq->data = IAlloc->Alloc(pp.head.Length);
      memcpy(qq->data, pp.data, pp.head.Length);
    };
    FSectionsV[12].Contents->Add(qq);
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::StartReportV(void){
  bool bCheck;
  try {
    LHandle = 0;
    BiffBody = new TList();
    FLastDynSection = 13;
    FLastDynSectionH = 13;
    FTypeDiraction = tdVerticaly;
    if ( OnStartReport != NULL ) OnStartReport(this);
    try {
      if ( OpenInputBlank() ){
        if ( CreateOutputReport() ){
          try {
            PrepareFileHeaderV();
            PrepareSectionV("REPORTHEADER", 1);
            PrepareSectionV("GROUPHEADER", 2);
            PrepareSectionV("SUBGROUPHEADER", 3);
            PrepareSectionV("SUBSUBGROUPHEADER", 4);
            PrepareSectionV("SUPERSUBGROUPHEADER", 5);
            PrepareSectionV("BODY", 6);
            PrepareSectionV("SUPERSUBGROUPFOOTER", 7);
            PrepareSectionV("SUBSUBGROUPFOOTER", 8);
            PrepareSectionV("SUBGROUPFOOTER", 9);
            PrepareSectionV("GROUPFOOTER", 10);
            PrepareSectionV("REPORTFOOTER", 11);
            PrepareFileFooterV();
            OutSectionV("FILEHEADER", true, 0);
            lWM_REP_SECTION_PREPARE = true;
            if ( OnSectionPrepare != NULL ) OnSectionPrepare(this);
            lWM_REP_SECTION_PREPARE = false;
            FCurrRow = 0;
            OutSectionV("REPORTHEADER", true, 1);
            bCheck = true;
            if ( OnMoveTop != NULL ) OnMoveTop(this, bCheck);
            while (! bCheck ){
              OutSectionV("GROUPHEADER", false, 2);
              OutSectionV("SUBGROUPHEADER", false, 3);
              OutSectionV("SUBSUBGROUPHEADER", false, 4);
              OutSectionV("SUPERSUBGROUPHEADER", false, 5);
              OutSectionV("BODY", true, 6);
              OutSectionV("SUPERSUBGROUPFOOTER", false, 7);
              OutSectionV("SUBSUBGROUPFOOTER", false, 8);
              OutSectionV("SUBGROUPFOOTER", false, 9);
              OutSectionV("GROUPFOOTER", false, 10);
              bCheck = true;
              if ( OnMoveNext != NULL ) OnMoveNext(this, bCheck);
            };
            OutSectionV("REPORTFOOTER", true, 11);
            OutSectionV("FILEFOOTER", true, 12);
          } __finally {
            CloseSectionsV();
          };
        } else if ( OnReportError != NULL ) OnReportError(this, WM_REP_CREATE_ERROR, 0, "Create Error");
      } else if ( OnReportError != NULL ) OnReportError(this, WM_REP_OPEN_ERROR, 0, "Open Error");
    } __finally {
      CloseInputBlank();
      CloseOutputReport();
    };
    if ( OnEndReport != NULL ) OnEndReport(this);
  } __finally {
    FTypeDiraction = tdNotDefined;
    CloseBody();
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::PrepareSectionV(AnsiString SectionName, int SectionNum){
  int i;
  TBiffRec pp;
  pTBiffRec qq;
  char sLen;
  AnsiString sName;
  WORD r, r1, r2;
  BYTE c, c1, c2;
  bool Found;
  AnsiString ss;
  double ff;
  WORD bb;
  DWORD lw;
  r1 = 0;
  r2 = 0;
  c1 = 0;
  c2 = 0;
  Found = false;
  for (i=0;i<FSectionsV[0].Contents->Count;i++){
    pp = *((pTBiffRec)(FSectionsV[0].Contents->Items[i]));
    if (pp.head.Opcode == 536){    //Names definition
      sLen = *((BYTE*)(((char*)pp.data) + 3));
      sName = AnsiString((char*)(pp.data) + 6, sLen);
      if ( sName == SectionName ){
        r1 = *((WORD*)((char*)(pp.data) + pp.head.Length - 6));
        r2 = *((WORD*)((char*)(pp.data) + pp.head.Length - 4));
        c1 = *((WORD*)((char*)(pp.data) + pp.head.Length - 2));
        c2 = *((WORD*)((char*)(pp.data) + pp.head.Length - 1));
        Found = true;
        break;
      };
    };
  };
  if ( Found ){
    FSectionsV[SectionNum].SectionName = SectionName;
    FSectionsV[SectionNum].SectionNum = SectionNum;
    FSectionsV[SectionNum].SectionUsed = true;
    FSectionsV[SectionNum].Contents = new TList();
    FSectionsV[SectionNum].RowsCount = r2 - r1 + 1;
    for (i=0;i<BiffBody->Count;i++){
      pp = *((pTBiffRec)(BiffBody->Items[i]));
      if ( pp.head.Opcode == 513 ){  //Blank cell
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ((r1 <= r) && (r <= r2)) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->r = r;
          qq->c = c;
          qq->d.Clear();
          qq->d = Null;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            memcpy(qq->data, pp.data, pp.head.Length);
          };
          FSectionsV[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 515 ){  //8 byte float
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ((r1 <= r) && (r <= r2)) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->r = r;
          qq->c = c;
          ff = *((double*)((char*)(pp.data) + 6));
          qq->d.Clear();
          qq->d = ff;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            memcpy(qq->data, pp.data, pp.head.Length);
          };
          FSectionsV[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 516 ){  //Label
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ((r1 <= r) && (r <= r2)) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->r = r;
          qq->c = c;
          ss = AnsiString((char*)(pp.data) + 8, *((WORD*)((char*)(pp.data) + 6)));
          qq->d.Clear();
          qq->d = ss;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            memcpy(qq->data, pp.data, pp.head.Length);
          };
          FSectionsV[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 517 ){  //Bool
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ((r1 <= r) && (r <= r2)) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->r = r;
          qq->c = c;
          bb = *((WORD*)((char*)(pp.data) + 6));
          qq->d.Clear();
          if (bb == 1){
            qq->d = true;
          } else
            qq->d = false;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            memcpy(qq->data, pp.data, pp.head.Length);
          };
          FSectionsV[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      /*
      if pp.head.Opcode = 520 then begin  //Row
        r := pWord(pp.data)^;
        if ((r1 <= r) and (r <= r2)) then begin
          GetMem(qq, SizeOf(TBiffRec));
          FillChar(qq^, SizeOf(TBiffRec), 0);
          qq^.head.Opcode := pp.head.Opcode;
          qq^.head.Length := pp.head.Length;
          qq^.data := nil;
          qq^.rb := r - r1;
          qq^.r := r;
          qq^.c := 0;
          qq^.c1 := pWord(pChar(pp.data)+ 2)^;
          qq^.c2 := pWord(pChar(pp.data)+ 4)^;
          qq^.w  := pWord(pChar(pp.data)+ 6)^;
          qq^.d := Unassigned;
          qq^.d := NULL;
         if pp.head.Length > 0 then begin
            GetMem(qq^.data, pp.head.Length);
            Move(pp.data^, qq^.data^, pp.head.Length);
          end;
          FSectionsV[SectionNum].Contents.Add(qq);
          if i > LHandle then LHandle := i;
        end;
      end;
      */
      if ( pp.head.Opcode == 638 ){  //Cool cell - clear ass
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ((r1 <= r) && (r <= r2)) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->r = r;
          qq->c = c;
          lw = *((DWORD*)((char*)(pp.data) + 6));
          qq->d.Clear();
          qq->d = Ass2Number(lw);
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            memcpy(qq->data, pp.data, pp.head.Length);
          };
          FSectionsV[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 1030 ){ //Formula cell
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ((r1 <= r) && (r <= r2)) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->r = r;
          qq->c = c;
          qq->d.Clear();
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            memcpy(qq->data, pp.data, pp.head.Length);
          };
          FSectionsV[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutSectionV(AnsiString SectionName, bool bOut, int SectionNum){
  int i;
  TList* List;
  TBiffRec pp;
  bool bCheck;
  Variant V;
  bool H;
  AnsiString ContentColRow;
  int pInt, pInt1, pSt, iP;
  AnsiString sStr, sField;
  char* cc;
  char* cc1;
  FCurrentSection = SectionName;
  FCurrentSectionNum = SectionNum;
	if ( OnSectionBegin != NULL ) OnSectionBegin(this, SectionName, SectionNum);
	if ( FSectionsV[SectionNum].SectionUsed ){
    if ( OnSectionCheck != NULL ) OnSectionCheck(this, SectionName, SectionNum, bOut);
		if ( bOut ){
      List = FSectionsV[SectionNum].Contents;
      for(i=0;i<List->Count;i++){
        pp = *(pTBiffRec)(List->Items[i]);
        switch ( pp.head.Opcode ){
          case 513:
          case 515:
          case 516:
          case 517:
          case 638:
          case 1030:
            bCheck = false;
            V.Clear();
            V = pp.d;
            if ( OnDataRequest != NULL ) OnDataRequest(this, SectionName, SectionNum, V, bCheck, FCurrRow + pp.rb + 1, pp.c + 1, pp.r + 1, pp.c + 1);
            if ( bCheck ){
              OutVariant(FOutputStream, V, pp);
            } else {
              H = false;
              if ( pp.head.Opcode == 516 ){ //Label
                ContentColRow = V;
                if ( OnRequestByNum != NULL){
                  pSt = 0;
                  while ( true ){
                    pInt = LScan(ContentColRow, FCharByNum, pSt);
                    if ( pInt == 0 ){ break; }else{ H = true;};
                    pSt = pInt;
                    iP = StrToIntDef(ContentColRow.SubString(pInt + 1, 4), -999999987);
                    if ( iP != -999999987 ){
                      sStr = "";
                      OnRequestByNum(this, SectionName, iP, sStr);
                      ContentColRow = ContentColRow.SubString(1, pInt - 1) + sStr + ContentColRow.SubString(pInt + 5, ContentColRow.Length());
                    };
                  };
                };
                if ( OnRequestByName != NULL ){
                  pSt = 0;
                  while ( true ){
                    pInt = LScan(ContentColRow, FCharByName, pSt);
                    if ( pInt == 0 ) break;
                    pInt1 = LScan(ContentColRow, FCharByName, pInt);
                    if ( pInt1 == 0 ){ break; }else{ H = true;};
                    pSt = pInt1;
                    sField = ContentColRow.SubString(pInt+1, pInt1-pInt-1);
                    sStr = "";
                    OnRequestByName(this, SectionName, sField, sStr);
                    ContentColRow = ContentColRow.SubString(1, pInt - 1) + sStr + ContentColRow.SubString(pInt1 + 1, ContentColRow.Length());
                  };
                };
              };
              if ( H ){
                OutVariant(FOutputStream, ContentColRow, pp);
              } else { //if not handled with OnRequestByNum or OnRequestByName
                //Copy with correct Row and Col
                (*(WORD*)(pp.data)) = FCurrRow + pp.rb;
                (*(WORD*)((char*)(pp.data) + 2)) = pp.c;;
                FOutputStream->WriteBuffer(&pp.head, sizeof(pp.head));
                FOutputStream->WriteBuffer(pp.data, pp.head.Length);
              };
            };
            break;
          /*
          520:      //Row
          begin
            //Copy with correct Row      !! not Col !!
            pWord(pp.data)^ := FCurrRow + pp.rb;
            FOutputStream.WriteBuffer(pp.head, SizeOf(pp.head));
            FOutputStream.WriteBuffer(pp.data^, pp.head.Length);

            //XLSRow[2] := FCurrRow + pp.rb;
            //XLSRow[3] := pp.c1;
            //XLSRow[4] := pp.c2;
            //XLSRow[5] := pp.w;
            //FOutputStream.WriteBuffer(XLSRow, SizeOf(XLSRow));

          end;
          */
          default:
            //Only copy
            FOutputStream->WriteBuffer(&pp.head, sizeof(pp.head));
            FOutputStream->WriteBuffer(pp.data, pp.head.Length);
            break;
        };
      };
			FCurrRow = FCurrRow + FSectionsV[SectionNum].RowsCount;
      if ( OnSectionEnd != NULL ) OnSectionEnd(this, SectionName, SectionNum);
		};
	};
  if ( OnSectionComplit != NULL ) OnSectionComplit(this, SectionName, SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::CloseSectionsV(void){
  int i, j, k;
  pTBiffRec pp;
	for(i=0;i<MAX_SECTION_NUM;i++){
	  if ( FSectionsV[i].SectionUsed ){
		  FSectionsV[i].SectionUsed = false;
      k = FSectionsV[i].Contents->Count;
      for(j=0;j<k;j++){
        pp = (pTBiffRec)(FSectionsV[i].Contents->Items[j]);
        if ( pp->head.Length > 0 )
          IAlloc->Free(pp->data);
        IAlloc->Free(pp);
      };
      FSectionsV[i].Contents->Free();
      FSectionsV[i].Contents = NULL;
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::PrepareFileHeaderH(void){
  TBiffRecHeader r_h;
  pTBiffRec pp;
	FSectionsH[0].SectionName = "FILEHEADER";
	FSectionsH[0].SectionNum = 0;
	FSectionsH[0].SectionUsed = true;
  FSectionsH[0].Contents = new TList();
  while ( true ){
    FInputStream->Read((void*)&r_h, 4);
    pp = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
    memset(pp, 0, sizeof(TBiffRec));
    pp->head.Opcode = r_h.Opcode;
    pp->head.Length = r_h.Length;
    pp->data = NULL;
    pp->r = 0;
    pp->c = 0;
    pp->d = Unassigned;
    pp->d = Null;
    if ( r_h.Length > 0 ){
      pp->data = IAlloc->Alloc(r_h.Length);
      FInputStream->Read(pp->data, r_h.Length);
    };
    if ( r_h.Opcode == 0x7D ){ //Col
      BiffBody->Add(pp);
      break;
    };
    if ( r_h.Opcode == 0x200 ) break; //Dimention
    FSectionsH[0].Contents->Add(pp);
  };
  while ( true ){
    FInputStream->Read((void*)&r_h, 4);
    pp = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
    memset(pp, 0, sizeof(TBiffRec));
    pp->head.Opcode = r_h.Opcode;
    pp->head.Length = r_h.Length;
    pp->data = NULL;
    pp->r = 0;
    pp->c = 0;
    pp->d = Unassigned;
    pp->d = Null;
    if ( r_h.Length > 0 ){
      pp->data = IAlloc->Alloc(r_h.Length);
      FInputStream->Read(pp->data, r_h.Length);
    };
    BiffBody->Add(pp);
    if ( r_h.Opcode == 0x0A ) break; //EOF
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::PrepareFileFooterH(void){
  int i;
  TBiffRec pp;
  pTBiffRec qq;
	FSectionsH[12].SectionName = "FILEFOOTER";
	FSectionsH[12].SectionNum = 12;
	FSectionsH[12].SectionUsed = true;
  FSectionsH[12].Contents = new TList();
  for(i=LHandle + 1;i<BiffBody->Count;i++){
    pp = *((pTBiffRec)(BiffBody->Items[i]));
    if ( (pp.head.Opcode != 171) && (pp.head.Opcode != 153) ){
      qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
      memset(qq, 0, sizeof(TBiffRec));
      qq->head.Opcode = pp.head.Opcode;
      qq->head.Length = pp.head.Length;
      qq->data = NULL;
      qq->r = 0;
      qq->c = 0;
      qq->d = Unassigned;
      qq->d = Null;
      if ( pp.head.Length > 0 ){
        qq->data = IAlloc->Alloc(pp.head.Length);
        Move(pp.data, qq->data, pp.head.Length);
      };
      FSectionsH[12].Contents->Add(qq);
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::StartReportH(void){
  bool bCheck;
  try{
    LHandle = 0;
    BiffBody = new TList();
    FStreamA = new TMemoryStream();
    FStreamB = new TMemoryStream();
    FLastDynSection = 13;
    FLastDynSectionH = 13;
    FTypeDiraction = tdHorizontaly;
    if ( OnStartReport != NULL ) OnStartReport(this);
    try {
      if ( OpenInputBlank() ){
        if ( CreateOutputReport() ){
          try {
            PrepareFileHeaderH();
            PrepareSectionH("H_REPORTHEADER", 1);
            PrepareSectionH("H_GROUPHEADER", 2);
            PrepareSectionH("H_SUBGROUPHEADER", 3);
            PrepareSectionH("H_SUBSUBGROUPHEADER", 4);
            PrepareSectionH("H_SUPERSUBGROUPHEADER", 5);
            PrepareSectionH("H_BODY", 6);
            PrepareSectionH("H_SUPERSUBGROUPFOOTER", 7);
            PrepareSectionH("H_SUBSUBGROUPFOOTER", 8);
            PrepareSectionH("H_SUBGROUPFOOTER", 9);
            PrepareSectionH("H_GROUPFOOTER", 10);
            PrepareSectionH("H_REPORTFOOTER", 11);
            PrepareFileFooterH();
            OutSectionH("FILEHEADER", true, 0);
            lWM_REP_SECTION_PREPARE = true;
            if ( OnSectionPrepare != NULL ) OnSectionPrepare(this);
            lWM_REP_SECTION_PREPARE = false;
            FCurrCol = 0;
            OutSectionH("H_REPORTHEADER", true, 1);
            bCheck = True;
            if ( OnMoveTop != NULL ) OnMoveTop(this, bCheck);
            while ( !bCheck ){
              OutSectionH("H_GROUPHEADER", false, 2);
              OutSectionH("H_SUBGROUPHEADER", false, 3);
              OutSectionH("H_SUBSUBGROUPHEADER", false, 4);
              OutSectionH("H_SUPERSUBGROUPHEADER", false, 5);
              OutSectionH("H_BODY", true, 6);
              OutSectionH("H_SUPERSUBGROUPFOOTER", false, 7);
              OutSectionH("H_SUBSUBGROUPFOOTER", false, 8);
              OutSectionH("H_SUBGROUPFOOTER", false, 9);
              OutSectionH("H_GROUPFOOTER", false, 10);
              bCheck = true;
              if ( OnMoveNext != NULL ) OnMoveNext(this, bCheck);
            };
            OutSectionH("H_REPORTFOOTER", true, 11);
            OutSectionH("FILEFOOTER", true, 12);
            FlashHReport();
          } __finally {
            CloseSectionsH();
          };
        } else if ( OnReportError != NULL ) OnReportError(this, WM_REP_CREATE_ERROR, 0, "Create Error");
      } else if ( OnReportError != NULL ) OnReportError(this, WM_REP_OPEN_ERROR, 0, "Open Error");
    } __finally {
      CloseInputBlank();
      CloseOutputReport();
    };
    if ( OnEndReport != NULL ) OnEndReport(this);
  } __finally {
    FTypeDiraction = tdNotDefined;
    FStreamA->Free();
    FStreamB->Free();
    FStreamA = NULL;
    FStreamB = NULL;
    CloseBody();
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::PrepareSectionH(AnsiString SectionName, int SectionNum){
  int i;
  TBiffRec pp;
  pTBiffRec qq;
  BYTE sLen;
  AnsiString sName;
  WORD r, r1, r2;
  WORD col_b, col_e;
  BYTE c, c1, c2;
  bool Found;
  AnsiString ss;
  double ff;
  WORD bb;
  DWORD lw;
  r1 = 0;
  r2 = 0;
  c1 = 0;
  c2 = 0;
  Found = false;
  for(i=0;i<FSectionsH[0].Contents->Count;i++){
    pp = *(pTBiffRec)(FSectionsH[0].Contents->Items[i]);
    if ( pp.head.Opcode == 536 ){    //Names definition
      sLen = *((BYTE*)(((char*)pp.data) + 3));
      sName = AnsiString((char*)(pp.data) + 6, sLen);
      if ( sName == SectionName ){
        r1 = *((WORD*)((char*)(pp.data) + pp.head.Length - 6));
        r2 = *((WORD*)((char*)(pp.data) + pp.head.Length - 4));
        c1 = *((WORD*)((char*)(pp.data) + pp.head.Length - 2));
        c2 = *((WORD*)((char*)(pp.data) + pp.head.Length - 1));
        Found = true;
        break;
      };
    };
  };
  if ( Found ){
    FSectionsH[SectionNum].SectionName = SectionName;
    FSectionsH[SectionNum].SectionNum = SectionNum;
    FSectionsH[SectionNum].SectionUsed = true;
    FSectionsH[SectionNum].Contents = new TList();
    FSectionsH[SectionNum].RowsCount = r2 - r1 + 1;
    FSectionsH[SectionNum].ColsCount = c2 - c1 + 1;
    for(i=0;i<BiffBody->Count;i++){
      pp = *((pTBiffRec)(BiffBody->Items[i]));
      if ( pp.head.Opcode == 125 ){  //Col definition
        col_b = *((WORD*)(pp.data));
        col_e = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (c1 <= col_b) && (col_b <= c2) ) || ( (c1 <= col_e) && (col_e <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->col_b = col_b;
          qq->col_e = col_e;
          qq->cb = c1;
          qq->d.Clear();
          qq->d = Null;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 513 ){  //Blank cell
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (r1 <= r) && (r <= r2) ) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->cb = c - c1;
          qq->r = r;
          qq->c = c;
          qq->d.Clear();
          qq->d = Null;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 515 ){  //8 byte float
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (r1 <= r) && (r <= r2) ) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->cb = c - c1;
          qq->r = r;
          qq->c = c;
          ff = *((double*)((char*)(pp.data) + 6));
          qq->d.Clear();
          qq->d = ff;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 516 ){  //Label
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (r1 <= r) && (r <= r2) ) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->cb = c - c1;
          qq->r = r;
          qq->c = c;
          ss = AnsiString((char*)(pp.data) + 8, *((WORD*)((char*)(pp.data) + 6)));
          qq->d.Clear();
          qq->d = ss;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 517 ){  //Bool
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (r1 <= r) && (r <= r2) ) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->cb = c - c1;
          qq->r = r;
          qq->c = c;
          bb = *((WORD*)((char*)(pp.data) + 6));
          qq->d.Clear();
          if ( bb == 1 ){
            qq->d = true;
          } else {
            qq->d = false;
          };
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 638 ){  //Cool cell - clear ass
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (r1 <= r) && (r <= r2) ) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->cb = c - c1;
          qq->r = r;
          qq->c = c;
          lw = *((DWORD*)((char*)(pp.data) + 6));
          qq->d.Clear();
          qq->d = Ass2Number(lw);
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
      if ( pp.head.Opcode == 1030 ){  //Formula cell
        r = *((WORD*)(pp.data));
        c = *((WORD*)((char*)(pp.data)+ 2));
        if ( ( (r1 <= r) && (r <= r2) ) && ( (c1 <= c) && (c <= c2) ) ){
          qq = (pTBiffRec)IAlloc->Alloc(sizeof(TBiffRec));
          memset(qq, 0, sizeof(TBiffRec));
          qq->head.Opcode = pp.head.Opcode;
          qq->head.Length = pp.head.Length;
          qq->data = NULL;
          qq->rb = r - r1;
          qq->cb = c - c1;
          qq->r = r;
          qq->c = c;
          qq->d.Clear();
          qq->d = Null;
          if ( pp.head.Length > 0 ){
            qq->data = IAlloc->Alloc(pp.head.Length);
            Move(pp.data, qq->data, pp.head.Length);
          };
          FSectionsH[SectionNum].Contents->Add(qq);
          if ( i > LHandle ) LHandle = i;
        };
      };
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutSectionH(AnsiString SectionName, bool bOut, int SectionNum){
  int i;
  TList* List;
  TBiffRec pp;
  bool bCheck;
  Variant V;
  bool H;
  AnsiString ContentColRow;
  int pInt, pInt1, pSt, iP;
  AnsiString sStr, sField;
  TStream* WStream;
  FCurrentSection = SectionName;
  FCurrentSectionNum = SectionNum;
  if ( FCurrentSectionNum == 0 ){
    WStream = FStreamA;
  } else {
    WStream = FStreamB;
  };
	if ( OnSectionBegin != NULL ) OnSectionBegin(this, SectionName, SectionNum);
	if ( FSectionsH[SectionNum].SectionUsed ){
    if ( OnSectionCheck != NULL ) OnSectionCheck(this, SectionName, SectionNum, bOut);
		if ( bOut ){
      List = FSectionsH[SectionNum].Contents;
      for(i=0;i<List->Count;i++){
        pp = *((pTBiffRec)(List->Items[i]));
        switch ( pp.head.Opcode ){
          case 513:
          case 515:
          case 516:
          case 517:
          case 638:
          case 1030:
            bCheck = false;
            V.Clear();
            V = pp.d;
            if ( OnDataRequest != NULL ) OnDataRequest(this, SectionName, SectionNum, V, bCheck, pp.r + 1, FCurrCol + pp.cb + 1, pp.r + 1, pp.c + 1);
            if ( bCheck ){
              OutVariant(WStream, V, pp);
            } else {
              H = false;
              if ( pp.head.Opcode == 516 ){ //Label
                ContentColRow = V;
                if ( OnRequestByNum != NULL){
                  pSt = 0;
                  while ( true ){
                    pInt = LScan(ContentColRow, FCharByNum, pSt);
                    if ( pInt == 0 ){ break; } else { H = true; };
                    pSt = pInt;
                    iP = StrToIntDef(ContentColRow.SubString(pInt + 1, 4), -999999987);
                    if ( iP != -999999987 ){
                      sStr = "";
                      OnRequestByNum(this, SectionName, iP, sStr);
                      ContentColRow = ContentColRow.SubString(1, pInt - 1) + sStr + ContentColRow.SubString(pInt + 5, ContentColRow.Length());
                    };
                  };
                };
                if ( OnRequestByName != NULL ){
                  pSt = 0;
                  while ( true ){
                    pInt = LScan(ContentColRow, FCharByName, pSt);
                    if ( pInt == 0 ) break;
                    pInt1 = LScan(ContentColRow, FCharByName, pInt);
                    if ( pInt1 == 0 ){ break; }else{ H = true;};
                    pSt = pInt1;
                    sField = ContentColRow.SubString(pInt+1, pInt1-pInt-1);
                    sStr = "";
                    OnRequestByName(this, SectionName, sField, sStr);
                    ContentColRow = ContentColRow.SubString(1, pInt - 1) + sStr + ContentColRow.SubString(pInt1 + 1, ContentColRow.Length());
                  };
                };
              };
              if ( H ){
                OutVariant(WStream, ContentColRow, pp);
              } else { //if not handled with OnRequestByNum or OnRequestByName
                //Copy with correct Row and Col
                *((WORD*)(pp.data)) = pp.r;
                *((WORD*)((char*)(pp.data) + 2)) = FCurrCol + pp.cb;
                WStream->WriteBuffer(&(pp.head), sizeof(pp.head));
                WStream->WriteBuffer(pp.data, pp.head.Length);
              };
            };
            break;
          case 125:      //Col
            //Copy with correct Col
            *((WORD*)(pp.data)) = FCurrCol + pp.col_b - pp.cb;
            *((WORD*)((char*)(pp.data) + 2)) = FCurrCol + pp.col_e - pp.cb;
            FStreamA->WriteBuffer(&(pp.head), sizeof(pp.head));
            FStreamA->WriteBuffer(pp.data, pp.head.Length);
            break;
          default:
            //Only copy
            WStream->WriteBuffer(&(pp.head), sizeof(pp.head));
            WStream->WriteBuffer(pp.data, pp.head.Length);
            break;
        };
      };
			FCurrCol = FCurrCol + FSectionsH[SectionNum].ColsCount;
      if ( OnSectionEnd != NULL ) OnSectionEnd(this, SectionName, SectionNum);
		};
	};
  if ( OnSectionComplit != NULL ) OnSectionComplit(this, SectionName, SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::CloseSectionsH(void){
  int i, j, k;
  pTBiffRec pp;
	for(i=0;i<=MAX_SECTION_NUM;i++){
	  if ( FSectionsH[i].SectionUsed ){
		  FSectionsH[i].SectionUsed = false;
      k = FSectionsH[i].Contents->Count;
      for(j=0;j<k;j++){
        pp = (pTBiffRec)(FSectionsH[i].Contents->Items[j]);
        if ( pp->head.Length > 0 )
          IAlloc->Free(pp->data);
        IAlloc->Free(pp);
      };
      FSectionsH[i].Contents->Free();
      FSectionsH[i].Contents = NULL;
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::FlashHReport(void){
  FStreamA->WriteBuffer(XLSDimension, sizeof(XLSDimension));
  FStreamA->Seek(0, soFromBeginning);
  FOutputStream->CopyFrom(FStreamA, FStreamA->Size);
  FStreamB->Seek(0, soFromBeginning);
  FOutputStream->CopyFrom(FStreamB, FStreamB->Size);
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::StartBiDirectionReport(void){
  AnsiString cpTempFile;
  AnsiString cpOldOut;
  char tmpp[MAX_PATH + 1];
  try {
    cpOldOut = OutputBlank;
    __GetTmpFileName(tmpp);
    cpTempFile = tmpp;
    OutputBlank = cpTempFile;
    StartReportH();
    InputBlank = cpTempFile;
    OutputBlank = cpOldOut;
    StartReportV();
  } __finally {
    DeleteFile(cpTempFile);
  };
};

//---------------------------------------------------------------------------
bool __fastcall TXLS4Report::OpenInputBlank(void){
  bool Result;
  if ( FInputStream != NULL ){
    FInputStream->Seek(0, soFromBeginning);
    Result = true;
  } else {
    try{
      FInputStream = new TFileStream(FInputBlank, fmOpenRead | fmShareDenyWrite);
      Result = true;
    } catch(...) {
      FInputStream = NULL;
      Result = false;
    };
  };
  return Result;
};

//---------------------------------------------------------------------------
bool __fastcall TXLS4Report::CreateOutputReport(void){
  bool Result;
  if ( FOutputStream != NULL ){
    FOutputStream->Seek(0, soFromBeginning);
    Result = true;
  } else {
    try {
      FOutputStream = new TFileStream(FOutputBlank, fmCreate);
      Result = true;
    } catch(...) {
      FOutputStream = NULL;
      Result = false;
    };
  };
  return Result;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::CloseInputBlank(void){
  FInputStream->Free();
  FInputStream = NULL;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::CloseOutputReport(void){
  FOutputStream->Free();
  FOutputStream = NULL;
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutVariant(TStream* FOutputStream, Variant V, TBiffRec& pp){
  int C;
  AnsiString S;
  WORD B;
  switch ( VarType(V) ){
    case varEmpty:
    case varNull:
      switch ( FTypeDiraction ){
      case tdVerticaly:
        XLSBlank[2] = FCurrRow + pp.rb;
        XLSBlank[3] = pp.c;
        break;
      case tdHorizontaly:
        XLSBlank[2] = pp.r;
        XLSBlank[3] = FCurrCol + pp.cb;
        break;
      };
      XLSBlank[4] = *((WORD*)((char*)(pp.data) + 4));
      FOutputStream->WriteBuffer(XLSBlank, sizeof(XLSBlank));
      break;
    case varSmallint:
    case varInteger:
      C = V;
      if ( (-536870912 <= C) & (C <= 536870911) ){
        C = (C << 2) + 2;
        switch ( FTypeDiraction ){
        case tdVerticaly:
          XLSRK[2] = FCurrRow + pp.rb;
          XLSRK[3] = pp.c;
          break;
        case tdHorizontaly:
          XLSRK[2] = pp.r;
          XLSRK[3] = FCurrCol + pp.cb;
          break;
        };
        XLSRK[4] = *((WORD*)((char*)(pp.data) + 4));
        FOutputStream->WriteBuffer(XLSRK, sizeof(XLSRK));
        FOutputStream->WriteBuffer(&C, sizeof(C));
      } else
        OutNumber(FOutputStream, V, pp, C);
      break;
    case varSingle:
    case varDouble:
    case varCurrency:
    case varDate:
      OutNumber(FOutputStream, V, pp, V);
      break;
    case varOleStr:
    case varString:
      S = V;
      XLSLabel[1] = S.Length() + 8;
      switch ( FTypeDiraction ){
      case tdVerticaly:
        XLSLabel[2] = FCurrRow + pp.rb;
        XLSLabel[3] = pp.c;
        break;
      case tdHorizontaly:
        XLSLabel[2] = pp.r;
        XLSLabel[3] = FCurrCol + pp.cb;
        break;
      };
      XLSLabel[4] = *((WORD*)((char*)(pp.data) + 4));
      XLSLabel[5] = S.Length();
      FOutputStream->WriteBuffer(XLSLabel, sizeof(XLSLabel));
      FOutputStream->WriteBuffer(S.c_str(), S.Length());
      break;
    case varBoolean:
      if ( V ){
        B = 1;
      }else{
        B = 0;
      };
      switch ( FTypeDiraction ){
      case tdVerticaly:
        XLSBool[2] = FCurrRow + pp.rb;
        XLSBool[3] = pp.c;
        break;
      case tdHorizontaly:
        XLSBool[2] = pp.r;
        XLSBool[3] = FCurrCol + pp.cb;
        break;
      };
      XLSBool[4] = *((WORD*)((char*)(pp.data) + 4));
      FOutputStream->WriteBuffer(XLSBool, sizeof(XLSBool));
      FOutputStream->WriteBuffer(&B, sizeof(B));
      break;
  };
};

//---------------------------------------------------------------------------
void __fastcall TXLS4Report::OutNumber(TStream* FOutputStream, Variant V, TBiffRec& pp, double F){
    switch ( FTypeDiraction ){
    case tdVerticaly:
      XLSNumber[2] = FCurrRow + pp.rb;
      XLSNumber[3] = pp.c;
      break;
    case tdHorizontaly:
      XLSNumber[2] = pp.r;
      XLSNumber[3] = FCurrCol + pp.cb;
      break;
    };
    XLSNumber[4] = *((WORD*)((char*)(pp.data) + 4));
    FOutputStream->WriteBuffer(XLSNumber, sizeof(XLSNumber));
    FOutputStream->WriteBuffer(&F, sizeof(F));
};

//---------------------------------------------------------------------------



Variant __fastcall Ass2Number(DWORD j){
  int x;
  DWORD m;
  int p;
  long double F;
  bool q;
  bool q1;
  bool sign;
  Variant Result;
  if ( j <= 3 ){
    Result = 0;
  } else {
    q1 = ((j & 1) == 1);
    if ((j & 2) == 2){
      p = j;
      q = ((DWORD)(p) == ((DWORD)(p) | 0x80000000));
      p = p >> 2;
      if ( q )
        p = (DWORD)(p) | 0xC0000000;
      Result = p;
    } else {
      sign = (j == (j | 0x80000000));
      p = j;
      q = (p == (p | 0x40000000));
      p = p & 0x7FFFFFFF;
      p = p >> 20;
      p = p ^ 0x00000400;
      if ( !q )
        p = (DWORD)(p) | 0xfffff800;
      x = p - 17;
      p = j & 0x000FFFFF;
      p = p | 0x00100000;
      m = (p >> 2);
      F = ldexpl(m, x);   //m*exp2(x);
      if ( sign )
        F = -F;
      if ( IsIntOrFloat(j) == ftInteger )
        Result = (int)F;
    };
    if ( q1 )
      Result = Result * 0.01;
  };
  return Result;
};

TFieldType __fastcall IsIntOrFloat(DWORD p){
  bool b;
  DWORD q;
  int mpos;
  TFieldType Result;
  q = p;
  b = (p == (p | 0x40000000));  //  Second left bit is set
  p = p >> 20;
  p = p ^ 0x00000400;
  if ( ! b ) p = p | 0xfffff800;
  p++;
  q = q & 0x000FFFFF;
  q = q >> 1;
  mpos = 0;
  if ( q > 0 ){
    mpos = 19;
    while ( true ){
      mpos--;
      q = q >> 1;
      if ((q & 1) == 1) break;
    };
  };
  if ( mpos > (int)(p) ){
    Result = ftFloat;  //ShowMessage('Value must not be integer')
  } else
    Result = ftInteger; //ShowMessage('Value is integer');
  return Result;
};

//------------------------------------------------------------------------------
void __GetTmpFileName(char * cpTempFile /*Must be MAX_PATH + 1 length*/){
  memset(cpTempFile, 0, MAX_PATH + 1);
  GetTempPath(MAX_PATH, cpTempFile);
  GetTempFileName(cpTempFile, "", 0, cpTempFile);
};

#pragma pack(pop)
